﻿<?php
#!/usr/local/bin/php
#鍋田辞書P Ver 1.2(PHPスクリプト)
#NabetaJisho P Ver 1.1 (2013/9/24)(PHP script)
#NabetaJisho P Ver 1.2 (2014/3/31。スクリプトの配布開始日)(PHP script)
#鍋田辞書 P(NabetaJisho P) Copyright (C) 2010-2014 大場正輝(Oba Masaki) All Rights Reserved.";
#http://wwww.nabeta.tk
#admin@nabeta.tk
#Windows版 鍋田辞書 Ver 4.2以降からCGI辞書用に出力した辞書データを検索するPHPスクリプトです。
#Windows版の鍋田辞書はデータの書き込みや編集ができますがPHP版は読み込み専用です。
#PHP版よりもWindows版の方が機能が豊富です。それでもPHP版の検索指定は通常の辞書サイトのCGIよりは多いと思います。
#Perl版鍋田辞書CGIもありますがPHP版の方が開発が進んでいます。
#モジュール版PHPのセーフモードに対応しています。
#モジュール版PHPのセーフモードでない方法で動作させる場合は、スクリプト行頭に「#!/usr/local/bin/php」を追加し、スクリプト名の拡張子をcgiに変える必要があるかも知れません。(サーバーの設定で違うと思います。)
#鍋田辞書Windows版から出力したnabeta.cgidatというファイルがデータファイルです。
#複数辞書を使用する場合は二つ目以降はnabeta2.cgidat～nabeta20.cgidatがデフォルト名で、$dic_name[]を書き換えることによりファイル名を変更できます。
#単語のインデックスファイルを持っています。
#先頭一致または完全一致且つ大文字小文字の区別がある場合はバイナリサーチで検索できます。
#
#ライセンス license
#このPHPスクリプトはフリーソフトですが、著作権を放棄しておりません。
#無料。商用利用可。改変可。改変した場合のソース公開の義務なし。
#再配布可ですが、配布には著作権の表記が必要。
#ネットでオンラインサイトとして公開する場合は、http://www.nabeta.tk/ へのリンクと著作権表記が必要です。
#リンクの例: <a href="http://www.nabeta.tk/">鍋田辞書</a>
#著作権表記の例:鍋田辞書P<br>Ver 1.2 (C) 2010-2014<br>大場正輝(Oba Masaki) All Rights Reserved.
#データのライセンスは別ライセンスになっておりますので各データの各著作権者の決めたルールに従ってください。
#鍋田辞書オリジナルのデータ(鍋田辞書作者が作ったデータ)は、無許可での一般WEB公開を禁止しています。
#ローカル環境で、IP 127.0.0.1からのみアクセスでそれ以外のアクセスを禁止している環境であれば、一般WEB公開や再配布に該当しないので鍋田辞書オリジナルのデータをこのスクリプトで使うことが可能です。
#寄付は受け付けます。「鍋田辞書 Windows版」のヘルプのライセンス説明に銀行口座番号が書いてあります。
#
#nabeta.php パーミッション 755。ftpはアスキーモードで転送。
#nabeta.cgidat パーミッション はモジュール版PHPセーフモードなら644。そうでないなら600。ftpはバイナリモードで転送。 
#使い方説明HTMLファイルのphpdockt.htmlとphpdoc.htmlは改変、配布、二次利用は無料で自由です。

#先頭一致、または完全一致でで大文字小文字区別する指定の時に速く検索できます。
#それ以外では検索はほとんどの場合、遅くなります。
#大文字小文字を区別しないモードでも少し速く検索できる場合もあります。
#検索指定は、検索ボタン、ランダムボタン、Enterを押した時に有効で、リンクのクリックは無効です。
#SJISからUTF-8に動的に切り替えることができます。
#SJISとUTF-8を動的に切り替えた直後は入力した文字が化けます。もう一度入力し直して検索してください。
#Javascriptを使っている所があり、無い場合は一部の機能が動きませんが辞書検索はできます。
#「"」(ダブルクォート)が入った文字列の検索後に、「"」を単語入力欄に入れる処理でJavascriptで入れます。
#パソコンモードにあるクリアボタンと、上部のメッセージ表示にJavascriptを使います。。
#上部のメッセージは下部にも同じものがでます。
#使い方は、同梱のHTMLファイルまたは実行して表示されるリンクに書いてあります。

#対応モードは携帯電話からパソコンまで六種類あり。
#0:パソコンデフォルト(幅広いモード)
#1:スマートフォン(改行有り。UTF8)
#2:携帯電話UTF8デフォルト(画面広い携帯モードでUTF8)
#3:携帯電話SJISデフォルト(画面広い携帯モードでSJIS)
#4:携帯電話ミニ画面UTF8デフォルト(画面狭い携帯電話モードでUTF8)
#5:携帯電話ミニ画面SJISデフォルト(画面狭い携帯電話モードでSJIS)
#URL指定も可能。
#http://xxxx.nabeta.php?m=0 でパソコンモード指定。
#http://xxxx.nabeta.php?m=5 で携帯ミニSJISモード指定。
#次の行の数値を0～5の任意に書き換えることでデフォルト指定。
$mobilemodedef = 0;

#タイトルバーに表示されるタイトルを書く(パソコンモード)
$titlebar_pc = "鍋田辞書P";

#タイトルバーに表示されるタイトルを書く(携帯電話モード)
#携帯電話だと非表示の場合が多い。
$titlebar_kt = "鍋田辞書P(携帯)";

#ページに表示されるタイトルを書く(パソコンモード)
$title_pc = "<b>鍋田辞書P</b>";


#ページに表示されるタイトルを書く(携帯電話モード)
$title_kt = "<b>鍋田辞書P</b>";

#辞書の数の最大数を指定
$datafile_max = 20;

#データのファイル名を指定
#$dic_data1の設定は必須。
$dic_data[0] = "nabeta.cgidat";
$dic_data[1] = "nabeta2.cgidat";
$dic_data[2] = "nabeta3.cgidat";
$dic_data[3] = "nabeta4.cgidat";
$dic_data[4] = "nabeta5.cgidat";
$dic_data[5] = "nabeta6.cgidat";
$dic_data[6] = "nabeta7.cgidat";
$dic_data[7] = "nabeta8.cgidat";
$dic_data[8] = "nabeta9.cgidat";
$dic_data[9] = "nabeta10.cgidat";
$dic_data[10] = "nabeta11.cgidat";
$dic_data[11] = "nabeta12.cgidat";
$dic_data[12] = "nabeta13.cgidat";
$dic_data[13] = "nabeta14.cgidat";
$dic_data[14] = "nabeta15.cgidat";
$dic_data[15] = "nabeta16.cgidat";
$dic_data[16] = "nabeta17.cgidat";
$dic_data[17] = "nabeta18.cgidat";
$dic_data[18] = "nabeta19.cgidat";
$dic_data[19] = "nabeta20.cgidat";

$file1 = $dic_data[0];

#辞書名を指定
$dic_name[0] = "DIC1";
$dic_name[1] = "DIC2";
$dic_name[2] = "DIC3";
$dic_name[3] = "DIC4";
$dic_name[4] = "DIC5";
$dic_name[5] = "DIC6";
$dic_name[6] = "DIC7";
$dic_name[7] = "DIC8";
$dic_name[8] = "DIC9";
$dic_name[9] = "DIC10";
$dic_name[10] = "DIC11";
$dic_name[11] = "DIC12";
$dic_name[12] = "DIC13";
$dic_name[13] = "DIC14";
$dic_name[14] = "DIC15";
$dic_name[15] = "DIC16";
$dic_name[16] = "DIC17";
$dic_name[17] = "DIC18";
$dic_name[18] = "DIC19";
$dic_name[19] = "DIC20";


#このファイルのファイル名を自動で取得
if(isset($_SERVER['SCRIPT_NAME'])){
  $cgi_name = basename($_SERVER['SCRIPT_NAME']);
}
else{
  $cgi_name = "";
}

#内蔵IME
#0:内蔵IME使わない。 1:内蔵IME使う
#$use_ime_h[x]のxは、0から始まる辞書番号
$use_ime_h[0] = 0;
$use_ime_h[1] = 0;
$use_ime_h[2] = 0;
$use_ime_h[3] = 0;
$use_ime_h[4] = 0;
$use_ime_h[5] = 0;
$use_ime_h[6] = 0;
$use_ime_h[7] = 0;
$use_ime_h[8] = 0;
$use_ime_h[9] = 0;
$use_ime_h[10] = 0;
$use_ime_h[11] = 0;
$use_ime_h[12] = 0;
$use_ime_h[13] = 0;
$use_ime_h[14] = 0;
$use_ime_h[15] = 0;
$use_ime_h[16] = 0;
$use_ime_h[17] = 0;
$use_ime_h[18] = 0;
$use_ime_h[19] = 0;

#内蔵IMEデフォルトモード指定
#0:IME無し。 1:ローマ字IME 2:通常IME
#内蔵IMEを使わないなら($use_ime[x] = 0)でこの設定は無視。
#$ime_mode_h[x]のxは、0から始まる辞書番号
$ime_mode_h[0] = 0;
$ime_mode_h[1] = 0;
$ime_mode_h[2] = 0;
$ime_mode_h[3] = 0;
$ime_mode_h[4] = 0;
$ime_mode_h[5] = 0;
$ime_mode_h[6] = 0;
$ime_mode_h[7] = 0;
$ime_mode_h[8] = 0;
$ime_mode_h[9] = 0;
$ime_mode_h[10] = 0;
$ime_mode_h[11] = 0;
$ime_mode_h[12] = 0;
$ime_mode_h[13] = 0;
$ime_mode_h[14] = 0;
$ime_mode_h[15] = 0;
$ime_mode_h[16] = 0;
$ime_mode_h[17] = 0;
$ime_mode_h[18] = 0;
$ime_mode_h[19] = 0;

#内蔵IMEの入力言語指定
#0:韓国語IME。 1:タイ語IME　2:ロシア語　3:エスペラント語
#内蔵IMEを使わないなら($use_ime[x] = 0)この設定は無視。
#$ime_gengo_mode_h[x]のxは、0から始まる辞書番号
$ime_gengo_mode_h[0] = 0;
$ime_gengo_mode_h[1] = 0;
$ime_gengo_mode_h[2] = 0;
$ime_gengo_mode_h[3] = 0;
$ime_gengo_mode_h[4] = 0;
$ime_gengo_mode_h[5] = 0;
$ime_gengo_mode_h[6] = 0;
$ime_gengo_mode_h[7] = 0;
$ime_gengo_mode_h[8] = 0;
$ime_gengo_mode_h[9] = 0;
$ime_gengo_mode_h[10] = 0;
$ime_gengo_mode_h[11] = 0;
$ime_gengo_mode_h[12] = 0;
$ime_gengo_mode_h[13] = 0;
$ime_gengo_mode_h[14] = 0;
$ime_gengo_mode_h[15] = 0;
$ime_gengo_mode_h[16] = 0;
$ime_gengo_mode_h[17] = 0;
$ime_gengo_mode_h[18] = 0;
$ime_gengo_mode_h[19] = 0;

#データ内の一致件数を求めるかどうか指定。求めると検索時間がかかる場合がある。
#1:一致件数モード 0:表示する部分のみ読み込みデータ内の一致件数は求めない
#非表示の部分も含めデータに一致する件数を求める
#単語の先頭一致検索のみに効く。それ以外は検索時間がかかるので無効にした。
$icchi_kensuu_mode = 1;

#大文字小文字を区別しないかどうか指定。1を指定すると検索時間がかかる場合がある。
#0:大文字小文字区別をデフォルトでする。abcとaBcは違う文字として検索。
#1:大文字小文字区別をデフォルトでしない。abcとaBcは同じ文字して検索。
$nocasef = 0;

//0:ローマ字の頭文字で検索するリンクを付けない。
//1:ローマ字の頭文字で検索するリンクを付ける。
//タイ文字などその他の文字に変える場合は自分で変えて欲しい。
$kasiramoji_link = 0;

#表サイズ大(パソコン)(現バージョンは多分意味無し)
$hyou_size_dai = 780;

#表サイズ小(パソコン)(現バージョンは多分意味無し)(一覧から単語をクリックしたとき)
$hyou_size_syou = 500;

#訳語カットサイズ
#一覧表示で訳語をカットするサイズを指定。
#この文字数にカットするのではなく、行末の切りのいい所でカットする。
#一行だけのデータではカットしない。
#携帯電話指定の時は無効。
$yakugo_cut_size = 60;

#携帯ミニ時の訳語カットサイズ
#大きいデータではエラーになると思うので
$keitaimini_yakugo_cut_size = 1500;

#表サイズ大(モバイル)
$hyou_size_dai_mobile = 400;

#表サイズ小(モバイル)(一覧から単語をクリックしたとき)
$hyou_size_syou_mobile = 400;

#携帯電話(SJIS)フラグ(ボタン類を表示しない。)
#これは書き換えないで、$mobilemodedef=3または$mobilemodedef=5とする
$keitaif = 0;

#携帯電話でUnicode(UTF-8)指定。スマートフォン等
#これは書き換えないで、$mobilemodedef=1または$mobilemodedef=2または$mobilemodedef=4とする
$keitai_utf8f = 0;


#データ認識コード
#間違って他のデータを検索しないための鍋田辞書CGIデータという印
$data_version_code = 654018739;

$input_tango = "";
if(isset($_GET['it'])){
  $input_tango = $_GET['it']; //入力単語
}
#$input_tango = @$_GET['it'];
#$input_tango = @$_GET[it];

#PHPが勝手にエスケープした文字を元に戻す。
#PHPだと、「'」と「\」と「"」を入力すると前に「\」が付くので削除
$input_tango = stripslashes($input_tango);
//$input_tango = str_replace("\\'", "'", $input_tango);
//$input_tango = str_replace("\\\"", '"', $input_tango);
//$input_tango = str_replace("\\\\", "\\", $input_tango);

  //$input_tango = trim($input_tango,"\t\r\n0x0B\0"); //前後の改行とタブと垂直タブとNULLを削除
  $input_tango = trim($input_tango,"\t\r\n"); //前後の改行とタブを削除
  if(substr($input_tango,-1) === " "){
  //if($input_tango[strlen($input_tango)-1] === " ")
    //最後の一文字がスペースだったら
    $input_tango = substr($input_tango, 0, -1); //最後の一文字を削除
  }

$submit_str = "";
if(isset($_GET['rs'])) $submit_str = $_GET['rs']; //ランダム検索ボタン
$submit_str = stripslashes($submit_str);//PHPの勝手にエスケープを元に戻す
$moto_input_tango = $input_tango;
$oomoji_str = "";
if(isset($_GET['om'])) $oomoji_str = $_GET['om']; //大文字小文字区別なしチェックボックス
$ichigyou_str = "";
if(isset($_GET['ig'])) $ichigyou_str = $_GET['ig']; //改行をカンマに変えて一行にするチェックボックス
$yaku_cut_str = "";
if(isset($_GET['yc'])) $yaku_cut_str = $_GET['yc'];
$hyouji_kensuu_str = "20";
if(isset($_GET['hk'])) $hyouji_kensuu_str = $_GET['hk'];
#データ著作権ボタンのvalueに「表」など文字を含む場合、エスケープさせないと動かない環境とさせると動かない環境がある。
#「表」が0x5c「\」を含むからだと思われる。
#データ著作権ボタンから「表」という文字は消した。
#「データ著作権表示」から、「データ著作権」に変更。
$chosakuken = "";
if(isset($_GET['dc'])) $chosakuken = $_GET['dc']; //データ著作権ボタン
$chosakuken = stripslashes($chosakuken);//PHPの勝手にエスケープを元に戻す
$link_name = "";
if(isset($_GET['lk'])) $link_name = $_GET['lk'];
$link_name = stripslashes($link_name);//PHPの勝手にエスケープを元に戻す
$tymode = "";
if(isset($_GET['rb'])) $tymode = $_GET['rb'];
$smode = "";
if(isset($_GET['sl'])) $smode = $_GET['sl'];
$mobile_get_str = "";
if(isset($_GET['m'])) $mobile_get_str = $_GET['m'];
$link_encode = "";
if(isset($_GET['d'])) $link_encode = $_GET['d'];
$nc_moji = "";
if(isset($_GET['nc'])) $nc_moji = $_GET['nc'];
$mz_moji = "";
if(isset($_GET['mz'])) $mz_moji = $_GET['mz'];
$mr_moji = "";
if(isset($_GET['mr'])) $mr_moji = $_GET['mr'];
$mi_moji = "";
if(isset($_GET['mi'])) $mi_moji = $_GET['mi'];
$page_no = 0;
if(isset($_GET['pn'])) $page_no = intval($_GET['pn']);
$pmax = 0;
for($i = 0;$i<1000;$i++){
  $pb = "p" . $i;
  if(isset($_GET[$pb])){
    $pagez[$i] = $_GET[$pb];
    $pmax++;
  }
  else{
    break;
  }
}


Function make_angou($s)
{
  $a = "";
  $c = 0; 
  $len = strlen($s);
  for($i = 0;$i<$len;++$i){
    $c = ord(substr($s,$i,1));
    ++$c;
    if($c == 0x3b){
      $c = 0x58;
    }
    else
    if($c == 0x3a){
      $c = 0x59;
    }
    else
    if($c < 0x30 || ($c > 0x39 && $c < 0x41) || ($c > 0x5a && $c < 0x61) || $c > 0x7a){
      $c = 0x5a;
    }
    $a .= chr($c);
  }
  return $a;
}

Function make_koyuu_moji()
{
  $Http_host = "";
  $Script_name = "";
  if(isset($_SERVER['HTTP_HOST'])){
    $Http_host = $_SERVER['HTTP_HOST'];
  }


  if(isset($_SERVER['SCRIPT_NAME'])){
    $Script_name = $_SERVER['SCRIPT_NAME'];
  }

  $up = $Http_host;
  if(strncmp($up,"http://",7)== 0){
    $up = substr($up,7,strlen($up)-7);
  }

  $up2 = $Script_name;
  if(strstr($up2,"?")){
    $up2 = preg_replace("/?.*$/","",$up2);
  }
  if(strstr($up,":")){
    $up = strstr($up,":");
    $up = substr($up,1,strlen($up)-1);
  }
  else{
    $up = "";
    if(substr($up2,0,1) === "/"){
      $up2 = substr($up2,1,strlen($up2)-1);
    }
  }

  $up .= $up2; 
  return "njp" . make_angou($up);
}

$dic_no = 0; //辞書番号
if(isset($_GET['dd'])){
  $dic_moji = $_GET['dd'];
  $dic_no = intval($dic_moji);
  if(file_exists($dic_data[$dic_no]) == 0){
    $dic_no = 0;
  }
}

$mc_dic_no = -1;
$mc_im_no = -1;
$mc_jp_no = 0; //日本語キーボード指定 default 0 
$mc_fontindex = 3;
$mc_fontsize = "16";
$mc_sc_no = 0; //スクリーンキーボード表示指定 default 0 
$cooks = "";
if(isset($_COOKIE[make_koyuu_moji()])){
  if(strlen($cooks) > 3){
    $cooks = $_COOKIE[make_koyuu_moji()];
  }
}
if($cooks != ""){
  $cooks_h = explode('&', $cooks);
  if($cooks_h[0] != ""){
    $mc_dic_no = intval($cooks_h[0]);
  }
  if($cooks_h[1] != ""){
    if(isset($_GET['dd'])){
      if($mc_dic_no == $dic_no){
        $mc_im_no = intval($cooks_h[1]);
      }
    }
    else{
      $mc_im_no = intval($cooks_h[1]);
    }
  }
  if($cooks_h[2] != ""){
    $mc_fontindex = intval($cooks_h[2]);
  }
  if($cooks_h[3] != ""){
    $mc_fontsize = $cooks_h[3];
  }
  if($cooks_h[4] != ""){
    $mc_jp_no = intval($cooks_h[4]);
  }
  if($cooks_h[5] != ""){
    if(isset($_GET['dd'])){
      if($mc_dic_no == $dic_no){
        $mc_sc_no = intval($cooks_h[5]);
      }
    }
    else{
      $mc_sc_no = intval($cooks_h[5]);
    }
  }
}
else{
  //クッキーなし
  if(isset($_GET['jp'])){
    $mc_jp_no = 1;
  }
  else{
    $mc_jp_no = 0;
  }
}

if(isset($_GET['dd']) == 0){
  //URL指定に辞書番号がなく、クッキーに辞書選択番号があれば、辞書番号を書き換える。
  //ただし、書き換えた辞書番号の辞書ファイルが存在しなければ辞書番号をリセットする。
  if($mc_dic_no >= 0){
    $dic_no = $mc_dic_no;
    if(file_exists($dic_data[$dic_no]) == 0){
      $dic_no = 0;
    }
  }
}

$next_rc = 0;
$next_rc_tugi = 0;
$nextf = 0;
if($nc_moji == ""){
  $next_rc = 0;
}
else{
  $next_rc = intval($nc_moji);
  if($next_rc > 0){
    $nextf = 1;
  }
}

$moto_z_cnt = intval($mz_moji);
$moto_k_ichi = intval($mr_moji);
$get_mi = intval($mi_moji);




$mobilef = 0;
$keitai_minif = 0;
if($mobile_get_str != ""){
  $mobilemodedef = intval($mobile_get_str);
}

if($mobilemodedef == 0){
  $mobilef = 0;
  $keitaif = 0;
  $keitai_utf8f = 0;
  $sjisf = 0;
}
else
if($mobilemodedef == 1){
  $mobilef = 1;
  $keitaif = 0;
  $keitai_utf8f = 0;
  $sjisf = 0;
}
else
if($mobilemodedef == 2){
  $keitaif = 0;
  $keitai_utf8f = 1;
  $mobilef = 0;
  $sjisf = 0;
}
else
if($mobilemodedef == 3){
  $keitaif = 1;
  $keitai_utf8f = 0;
  $mobilef = 0;
  $sjisf = 1;
}
else
if($mobilemodedef == 4){
  $keitaif = 0;
  $keitai_utf8f = 1;
  $mobilef = 0;
  $sjisf = 0;
  $keitai_minif = 1;
}
else
if($mobilemodedef == 5){
  $keitaif = 1;
  $keitai_utf8f = 0;
  $mobilef = 0;
  $sjisf = 1;
  $keitai_minif = 1;
}

if($keitai_utf8f == 1){
  $keitaif = 1;
  $sjisf = 0;
}

if($keitaif){
  $tymode = "t";//単語
}

if($keitai_minif){
  $smode = "sentou";
}

if($use_ime_h[$dic_no] && $keitaif == 0){
  $imem = "";	
  if(isset($_GET['im'])){
    $imem = $_GET['im'];

    if($imem === "n"){
      $ime_mode_h[$dic_no] = 0;
    }
    else
    if($imem === "r"){
      $ime_mode_h[$dic_no] = 1;
    }
    else
    if($imem === "k"){
      $ime_mode_h[$dic_no] = 2;
    }
  }
  else
  if($mc_im_no >= 0){
    if($dic_no == $mc_dic_no){
      //URL指定にIMEモード指定がなく、
      //且つ、クッキーにIMEモードがあり
      //且つ、現在の辞書番号とクッキーの辞書番号が同じ場合にクッキーのIMEモードをセット
      $ime_mode_h[$dic_no] = $mc_im_no;
    }
  }
  
}

$get_input_tango = "";
if(isset($_GET['ut'])) $get_input_tango = $_GET['ut'];
$get_input_tango = stripslashes($get_input_tango);//PHPの勝手にエスケープを元に戻す

$zenkaku_space = "";

Function print_us($s)
{
  global $sjisf;
  if($sjisf){
    $s = iconv('utf-8', 'cp932', $s);
  }
  print $s;
}

Function conv2sjis($s)
{
  global $sjisf;
  if($sjisf){
    $s = iconv('utf-8', 'cp932', $s);
  }
  return $s;
}

Function conv2utf8($s)
{
  global $sjisf;
  if($sjisf){
    $s = iconv('cp932', 'utf8-8', $s);
  }
  return $s;
}

if($get_input_tango != ""){
  $get_input_tango = urldecode($get_input_tango);
  $get_input_tango = conv2sjis($get_input_tango);
  $moto_input_tango = $get_input_tango;
  $input_tango = $get_input_tango;
}



#ランダムボタンの文字列
$randoms = conv2sjis('ランダム');

if($submit_str === $randoms){
  $randomf = 1;
}
else{
  $randomf = 0;
}

#URLをブラウザに勝手にSJISに変換されないためのダミーUTF8文字列
#$utf8dumys = chr(0xe0) . chr(0xb8) . chr(0x97);
$utf8dumys = '%E0%B8%97';


$link_hyouji = 0;
if(strcmp($link_name,"")){
  if($link_encode === "s"){
    $input_tango = urldecode($link_name);
  }
  else{
    $input_tango = $link_name;
  }
  $link_hyouji = 1;
}
if($mobilef){
  $hyou_size_dai = $hyou_size_dai_mobile;
  $hyou_size_syou = $hyou_size_syou_mobile;
}
	
if(strcmp($tymode,"")==0){
  $tymode = "t";//単語
}

if(strcmp($smode,"")==0){
  $smode = "sentou";
}

if(strcmp($oomoji_str,"o")==0){
  if($nocasef == 1){
    $oomoji = 0;
  }
  else{
    $oomoji = 1;
  }
}
else{
  if($nocasef == 1){
    $oomoji = 1;
  }
  else{
    $oomoji = 0;
  }
}

if(strcmp($ichigyou_str,"i")==0){
  $ichigyou = 1;
}
else{
  $ichigyou = 0;
}

if($keitai_minif){
  $ichigyou = 0;
}

$yaku_cut = 0;
$mini_yaku_cut = 0;
if($keitai_minif){
  $mini_yaku_cut = 1;
  $yakugo_cut_size = $keitaimini_yakugo_cut_size;
}
else
if($keitaif == 0){
  if(strcmp($yaku_cut_str,"y")==0){
    $yaku_cut = 1;
  }
  else{
    $yaku_cut = 0;
  }
}

$moto_yaku_cut = $yaku_cut;

$moto_ichigyou = $ichigyou;
if($link_hyouji){
  $ichigyou = 0;
  $yaku_cut = 0;
}

#最大表示件数
$dmax = intval($hyouji_kensuu_str);

if($dmax > 100){
  $dmax = 100;
}

$moto_oomoji = $oomoji;
if($oomoji){
  if(preg_match('/[a-z]/i',$input_tango)){
  }
  else{
    #ローマ字が含まれていないので、
    #大文字小文字同一オプションは不要。検索速度が遅くなるので消す。
    $oomoji = 0;
  }
}

if($randomf || $link_name != ""){
  $oomoji = 0;
}

$sentou_romaji = 0;

if($oomoji){
  //入力文字の先頭がローマ字かどうか調べる
  //先頭がローマ字なら、先頭一致と完全一致検索の時にローマ字の領域を過ぎたら早くループから抜ける
  $atama_str = substr($input_tango,0,1);
  if(preg_match('/[a-z]/i',$atama_str)){
    //入力文字の先頭がローマ字
    $sentou_romaji = 1;
  }
}

if($oomoji){
  $input_tango = strtolower($input_tango);
}
$itlen = strlen($input_tango);


#データの著作権表示ボタンの文字列
#「表」という文字を混ぜると環境により動作しない。
#GETで「\表」とエスケープされるが、エスケープさせて動作する環境としない環境がある。
#「表」が0x5c「\」記号を含んでいるのが原因だと思う。
#面倒くさいので「表」という文字は消した。
$data_chosakukens = conv2sjis('データの著作権');

#print("Content-type: text/html\n\n");
  print("<html><head>\n");

  if($sjisf){
    $moji_code="shift_jis";
  }
  else{
    $moji_code="utf-8";
  }
  print("<meta http-equiv=\"Content-Type\" content=\"text/html; charset=$moji_code\">\n");
  if($keitaif || $mobilef){
    $titlebar_s = $titlebar_kt;
    $title_s = $title_kt;
  }
  else{
    $titlebar_s = $titlebar_pc;
    $title_s = $title_pc;
  }
  $mcvs = "<title>$titlebar_s</title>\n";
  $mcvs .= '<meta NAME="description" content="オンライン辞書。鍋田辞書 PHP版。"><meta name="keywords" content="オンライン辞書,鍋田辞書,PHP">';
  print_us($mcvs);

  if($keitaif == 0){
    print("<script type=\"text/javascript\">\n<!--\n");
    print("function sizeTxt(n){\n");
    print("document.nabeta.it.style.fontSize = n.options[n.selectedIndex].value + \"px\"\n");
    print("documentnabetait.focus();\n");
    print("}\n-->\n</script>");
    print '<script type="text/javascript" src="./cookiej.mid"></script>';
  }
  if($use_ime_h[$dic_no] && $keitaif == 0){
    print "<script type=\"text/javascript\">\n<!--\nvar documentnabetaim;var documentnabetait;function setdocumentnabeta(){documentnabetaim=document.nabeta.im;documentnabetait=document.nabeta.it;}\n-->\n</script>";
    print '<script type="text/javascript" src="./tzh.mid"></script>';
    print '<script type="text/javascript" src="./tscn.mid"></script>';
  }
  else{
    print("<script type=\"text/javascript\">\n");
    print("<!--\n");
    print("function cfocus()\n{\ndocument.nabeta.it.focus();\n}\n");
    print("-->\n");
    print("</script>\n");
  }

  if($keitaif == 0){
    print("<script type=\"text/javascript\">\n");
    print("<!--\n");
    /*
    print("//");
    print $_SERVER['HTTP_HOST'];
    print("\n//");
    print $_SERVER['REQUEST_URI'];
    print("\n//");
    print $_SERVER['SCRIPT_NAME'];
    print("\n");
    */
    printf("var dic_no = %d;\n",$dic_no);
    printf("var use_ime_h = Array(%d);\n",$datafile_max);
    printf("var ime_mode_h = Array(%d);\n",$datafile_max);
    printf("var ime_gengo_mode = %d;\n",$ime_gengo_mode_h[$dic_no]);
    printf("var keitaif = %d;\n",$keitaif);
    for($i=0;$i<$datafile_max;$i++){
      printf("use_ime_h[%d] = %d;\n",$i,$use_ime_h[$i]);
    }
    for($i=0;$i<$datafile_max;$i++){
      printf("ime_mode_h[%d] = %d;\n",$i,$ime_mode_h[$i]);
    }
    print("function submit_ime(n)\n{\nif(use_ime_h[dic_no]==0){if(ime_mode_h[n]==0){document.nabeta.im.value=\"n\";}else if(ime_mode_h[n]==1){document.nabeta.im.value=\"r\";}else if(ime_mode_h[n]==2){document.nabeta.im.value=\"k\"};}\n");
    print("else{\n");
    print("if(ime_mode_h[n]==0){\n");
    print("document.nabeta.im[0].value=\"n\";");
    print("document.nabeta.im[1].value=\"n\";");
    print("document.nabeta.im[2].value=\"n\";");
    print("}\n");
    print("else\n");
    print("if(ime_mode_h[n]==1){\n");
    print("document.nabeta.im[0].value=\"r\";");
    print("document.nabeta.im[1].value=\"r\";");
    print("document.nabeta.im[2].value=\"r\";");
    print("}\n");
    print("else\n");
    print("if(ime_mode_h[n]==2){\n");
    print("document.nabeta.im[0].value=\"k\";");
    print("document.nabeta.im[1].value=\"k\";");
    print("document.nabeta.im[2].value=\"k\";");
    print("}\n");
    print("}\n}\n");
    print("-->\n");
    print("</script>\n");
  }


  if($keitaif == 0){
    print("<script type=\"text/javascript\">\n");
    print("<!--\n");
    print("function n_reset()\n{\ndocument.nabeta.it.value = \"\";document.nabeta.it.focus();\n}\n");
    print("-->\n");
    print("</script>\n");
  }

  print "</head>\n";
  
  if($use_ime_h[$dic_no] && $keitaif == 0){
    print "<body onload=\"setdocumentnabeta();init_ime();set_ime($ime_mode_h[$dic_no]);set_gengo($ime_gengo_mode_h[$dic_no]);set_keyboard($mc_jp_no);rikiten_button();onclick_init();setcookie();\">";
  }
  else{
    print('<body onload="cfocus();">');
  }

  
if($keitaif){
  $hh_button = "type=hidden";
  $hh_text = "type=hidden";
  $hh_radio = "type=hidden";
  $hh_checkbox = "type=hidden";
}
else{
  $hh_button = "type=button";
  $hh_text = "type=text";
  $hh_radio = "type=radio";
  $hh_checkbox = "type=checkbox";
}

  print("\n<form name =\"nabeta\" method=get action=./$cgi_name>\n");
  print_us("$title_s\n");

  for($i=0;$i<$datafile_max;$i++){
    $selected_h[$i] = "";
  }

  for($i=0;$i<$datafile_max;$i++){
    if($dic_no == $i && $dic_data[$i] != ""){
      $selected_h[$i] = "selected=\"selected\"";
      $file1 = $dic_data[$i];
      break;
    }
  }

  if($keitaif == 0){
    print("<select name=\"dd\" size=\"1\" onchange=\"setcookie();submit_ime(this.selectedIndex);submit()\">\n");
  }
  else{
    print("<select name=\"dd\" size=\"1\" onchange=\"submit()\">\n");
  }
  for($i=0;$i<$datafile_max;$i++){
    if(file_exists($dic_data[$i])){
      print_us("<option value=\"$i\" $selected_h[$i]>$dic_name[$i]</option>\n");
    }
  }
  print("</select>\n");
  print_us("　<a href=\"quiz.php?dd=$dic_no\">クイズ</a>");

  if($keitaif == 0){
    $ari = 0;
    for($i=0;$i<10;$i++){
      if($i == $mc_fontindex){
        $selected_h[$i] = "selected=\"selected\"";
        $ari = 1;
      }
      else{
        $selected_h[$i] = "";
      }
    }
    if($ari == 0){
      $selected_h[3] = "selected=\"selected\"";
      $font_size = 16;
    }
    else{
      if($mc_fontindex == 0){
        $font_size = 8;
      }
      else
      if($mc_fontindex == 1){
        $font_size = 10;
      }
      else
      if($mc_fontindex == 2){
        $font_size = 12;
      }
      else
      if($mc_fontindex == 3){
        $font_size = 16;
      }
      else
      if($mc_fontindex == 4){
        $font_size = 20;
      }
      else
      if($mc_fontindex == 5){
        $font_size = 24;
      }
      else
      if($mc_fontindex == 6){
        $font_size = 32;
      }
      else
      if($mc_fontindex == 7){
        $font_size = 38;
      }
      else
      if($mc_fontindex == 8){
        $font_size = 48;
      }
      else
      if($mc_fontindex == 9){
        $font_size = 56;
      }
    }
    print('<select name="fs" onchange="sizeTxt(this);setcookie()">');
    print("\n<option value=\"8\" $selected_h[0]>8px</option><br>\n");
    print("<option value=\"10\" $selected_h[1]>10px</option><br>\n");
    print("<option value=\"12\" $selected_h[2]>12px</option><br>\n");
    print("<option value=\"16\" $selected_h[3]>16px</option><br>\n");
    print("<option value=\"20\" $selected_h[4]>20px</option><br>\n");
    print("<option value=\"24\" $selected_h[5]>24px</option><br>\n");
    print("<option value=\"32\" $selected_h[6]>32px</option><br>\n");
    print("<option value=\"38\" $selected_h[7]>38px</option><br>\n");
    print("<option value=\"48\" $selected_h[8]>48px</option><br>\n");
    print("<option value=\"56\" $selected_h[9]>56px</option>");
    print('</select>');
  }
  print("<br>\n");

  print_us("単語");

  if($keitai_minif){
    $input_size = "12";
  }
  else
  if($keitaif || $mobilef){
    $input_size = "14";
  }
  else{
    $input_size = "30";
  }

  $stylesize = "";
  if($mc_fontsize != ""){
    $stylesize = "style=\"font-size:" . $mc_fontsize . "px\"";
  }
  if(strstr($moto_input_tango,"\"") && strstr($moto_input_tango,"'")){
    // " と　' の両方がある場合は、Javascriptで入力欄に代入
    //ダブルクォートをエスケープする。
    $dqs = str_replace("\"", "\\\"", $moto_input_tango);
    print("<input type=\"text\" name=\"it\" size=\"$input_size\" $stylesize>\n");
    print("<script type=\"text/javascript\">\n<!--\ndocument.nabeta.it.value=\"$dqs\"\n-->\n</script>\n");
  }
  else
  if(strstr($moto_input_tango,"\"") && strstr($moto_input_tango,"'")==0){
    // " があって、' がない。
    print("<input type=\"text\" name=\"it\" size=\"$input_size\" value='$moto_input_tango' $stylesize>\n");
  }
  else{
    print("<input type=\"text\" name=\"it\" size=\"$input_size\" value=\"$moto_input_tango\" $stylesize>\n");
  }

  $mcvs = conv2sjis("検索");
  print("<input type=\"submit\" value=\"$mcvs\">\n");
  if($keitaif==0){
    $mcvs = conv2sjis("クリア");
    print("<input value=\"$mcvs\" onclick=\"n_reset()\" $hh_button name=\"cl\">\n");
  }

  //ランダムボタン表示
  print("<input type=\"submit\" value=\"$randoms\" name=\"rs\">\n");

  if($keitaif){
  }
  else{
    //print_us("$zenkaku_space最大表示件数\n");
  }
$selected1 = "";
$selected2 = "";
$selected3 = "";
$selected4 = "";
$selected5 = "";
$selected6 = "";
$selected7 = "";
$selected8 = "";
$selected9 = "";
$selected10 = "";

if($dmax == 3){
  $selected1 = "selected=\"selected\"";
}
else
if($dmax == 10){
  $selected2 = "selected=\"selected\"";
}
else
if($dmax == 20){
  $selected3 = "selected=\"selected\"";
}
else
if($dmax == 40){
  $selected4 = "selected=\"selected\"";
}
else
if($dmax == 50){
  $selected5 = "selected=\"selected\"";
}
else
if($dmax == 60){
  $selected6 = "selected=\"selected\"";
}
else
if($dmax == 70){
  $selected7 = "selected=\"selected\"";
}
else
if($dmax == 80){
  $selected8 = "selected=\"selected\"";
}
else
if($dmax == 90){
  $selected9 = "selected=\"selected\"";
}
else
if($dmax == 100){
  $selected10 = "selected=\"selected\"";
}
else{
  if($keitaif){
    $selected2 = "selected=\"selected\"";
  }
  else{
    $selected3 = "selected=\"selected\"";
  }
}

  print("<select name=\"hk\" size=\"1\">\n");
  print("<option value=\"3\" $selected1>3</option>\n");
  print("<option value=\"10\" $selected2>10</option>\n");
  print("<option value=\"20\" $selected3>20</option>\n");
  print("<option value=\"40\" $selected4>40</option>\n");
  print("<option value=\"50\" $selected5>50</option>\n");
  print("<option value=\"60\" $selected6>60</option>\n");
  print("<option value=\"70\" $selected7>70</option>\n");
  print("<option value=\"80\" $selected8>80</option>\n");
  print("<option value=\"90\" $selected9>90</option>\n");
  print("<option value=\"100\" $selected10>100</option>\n");
  print("</select>\n");

  if($keitaif == 0 || $mobilef){
    print '<br>';
  }

  $tangoh = conv2sjis("単語");
  $yakugoh = conv2sjis("訳語");

if($keitaif){
}
else
if(strcmp($tymode,"t") == 0){//単語
  print_us("<input name=\"rb\" value=\"t\" checked=\"checked\" $hh_radio>$tangoh$zenkaku_space$zenaku_space<input name=\"rb\" value=\"y\"  $hh_radio>$yakugoh$zenkaku_space$zenkaku_space$zenkaku_space\n");
}
else{
  print_us("<input name=\"rb\" value=\"t\" $hh_radio>$tangoh$zenkaku_space$zenkaku_space<input name=\"rb\" value=\"y\" checked=\"checked\" $hh_radio>$yakugoh$zenkaku_space$zenkaku_space$zenkaku_space\n");
  if(strcmp($smode,"bubun") && strcmp($smode,"seiki")){
    $smode = "bubun";
  }
}


Function table_hyouji()
{
  global $link_hyouji;
  global $yaku_cut;
  global $hyou_size_syou;
  global $hyou_size_dai;
  global $keitaif;
  global $tangoh;
  global $yakugoh;
    if($keitaif){
	/*
        if($link_hyouji){
          print "<b>$tangoh/$yakugoh</b><br>\n";
        }
        else{
          print "<b>$tangoh</b><br>\n";
        }
	 */
    }
    else
    if($link_hyouji){
        //print "<table width='$hyou_size_syou' border='1' cellpadding='1' cellspacing='0'>\n";
        print "<table border='1' cellpadding='1' cellspacing='0'>\n";
        print "<tr>\n";
        print "<th>$tangoh/$yakugoh</th>\n";
        print "</tr>\n";
    }
    else{
      if($yaku_cut){ 
        //print "<table width='$hyou_size_syou' border='1' cellpadding='2' cellspacing='0'>\n";
        print "<table border='1' cellpadding='2' cellspacing='0'>\n";
      }
      else{
        //print "<table width='$hyou_size_dai' border='1' cellpadding='2' cellspacing='0'>\n";
        print "<table border='1' cellpadding='2' cellspacing='0'>\n";
      }
      print "<tr>\n";
      print "<th>$tangoh</th>\n";
      print "<th>$yakugoh</th>\n";
      print "</tr>\n";
    }
}

Function table_hyouji2()
{
  global $tangos;
  global $yakugo;
  global $link_hyouji;
  global $keitaif;
  global $randomf;
  if($keitaif){
    if($link_hyouji || $randomf){
      print "$tangos<br>$yakugo<br>\n";
    }
    else{
      print "$tangos<br>\n";
    }
  }
  else
  if($link_hyouji){
    print "<tr>\n";
    print "<td>";
    print "$tangos<br>$yakugo</td>\n";
    print "</tr>\n";
  }
  else{
    print "<tr>\n";
    print "<td>";
    print "$tangos</td>\n";
    print "<td>";
    print "$yakugo</td>\n";
    print "</tr>\n";
  }
}

Function tangos_syori($tangos)
{
  global $cgi_name;
  global $zen_pm;
  global $sjisf;
  global $utf8dumys;

  $tangos = conv2sjis($tangos);
  $tango_url = urlencode($tangos);

  $ens = "d=s";//エンコードした印
  $udumys = "";
  if($sjisf == 0){
    $udumys = "&v=" . $utf8dumys;
  }

  $tangos = "<a href=\"$cgi_name?$ens$udumys&lk=$tango_url$zen_pm\">$tangos</a>";

  return $tangos;
}

Function yakugo_cut_syori_br($yakugo_str)
{
  global $yakugo_cut_size;
  global $mini_yaku_cut;
    $len = strlen($yakugo_str);
    if($len < $yakugo_cut_size){
      return $yakugo_str;
    }
    $a = strpos($yakugo_str,"<br>",1);
    # ==の二個ではなく、===の三個を使う。
    #二個でもエラーにはならないが期待した動作をしない。
    if($a === false || $a == ""){
      #見つからない
    }
    else{
      if($a > $yakugo_cut_size){
        $yakugo_str = substr($yakugo_str,0,$a);
      }
      else{
        $a2 = strpos($yakugo_str,"<br>",$a+4); //$a+4
        if($a2 === false || $a2 == ""){
          #$yakugo_str = substr($yakugo_str,0,$a);
	}
	else{
          if($a2 > $yakugo_cut_size){
            $yakugo_str = substr($yakugo_str,0,$a2);
          }
	  else{
            if($mini_yaku_cut){
              $mae = $a2 + 4;
              while(1){
                $a3 = strpos($yakugo_str,"<br>",$mae);
                if($a3 > $yakugo_cut_size){
                  $yakugo_str = substr($yakugo_str,0,$mae);
                  break;
		}
	        if($a3 === 0 || $a3 == ""){
                  break;
	        }
                $mae = $a3+4;
	      }
            }
	    else{
              $a3 = strpos($yakugo_str,"<br>",$a2+4);
	      if($a3 === 0 || $a3 == ""){
                #$yakugo_str = substr($yakugo_str,0,$a2);
	      }
	      else{
                $yakugo_str = substr($yakugo_str,0,$a3);
	      }
	    }
	  }
        }
      }
    }
  return $yakugo_str;
}

Function yakugo_cut_syori($yakugo_str)
{
  global $yakugo_cut_size;
  global $mini_yaku_cut;
    $len = strlen($yakugo_str);
    if($len < $yakugo_cut_size){
      return $yakugo_str;
    }
    $a = strpos($yakugo_str,",",1);
    # ==の二個ではなく、===の三個を使う。
    #二個でもエラーにはならないが期待した動作をしない。
    if($a === false || $a == ""){
      #見つからない
    }
    else
    if($a > 0){
      if($a > $yakugo_cut_size){
        $yakugo_str = substr($yakugo_str,0,$a);
      }
      else{
        $a2 = strpos($yakugo_str,",",$a+1);
	if($a2 === 0 || $a2 == ""){
          #$yakugo_str = substr($yakugo_str,0,$a);
	}
	else{
          if($a2 > $yakugo_cut_size){
            $yakugo_str = substr($yakugo_str,0,$a2);
          }
	  else{
            if($mini_yaku_cut){
              $mae = $a2 + 1;
              while(1){
                $a3 = strpos($yakugo_str,",",$mae);
                if($a3 > $yakugo_cut_size){
                  $yakugo_str = substr($yakugo_str,0,$mae);
                  break;
		}
	        if($a3 === 0 || $a3 == ""){
                  break;
	        }
                $mae = $a3+1;
	      }
            }
	    else{
              $a3 = strpos($yakugo_str,",",$a2+1);
	      if($a3 === 0 || $a3 == ""){
                #$yakugo_str = substr($yakugo_str,0,$a2);
	      }
	      else{
                $yakugo_str = substr($yakugo_str,0,$a3);
	      }
	    }
	  }
        }
      }
    }
  return $yakugo_str;
}

Function yakugo_syori($yakugo_str)
{
  global $ichigyou;
  global $yaku_cut;
  global $mini_yaku_cut;
  global $sjisf;
  $htmlf = 0;
  $yakugo_str = conv2sjis($yakugo_str);

  if(preg_match("/^[ 	\r\n]*<html>/i",$yakugo_str)){
    $htmlf = 1;
  }
  if($htmlf){
    $yakugo_str = preg_replace("/^[ 	\r\n]*<html>/i","",$yakugo_str);
    $yakugo_str = preg_replace("/<\/html>/i","",$yakugo_str);
    if($yaku_cut || $mini_yaku_cut){
      $yakugo_str = yakugo_cut_syori_br($yakugo_str);
    }
    if($ichigyou){
      $yakugo_str = preg_replace("/<br>/i",",",$yakugo_str);
    }

    $yakugo_str = preg_replace("/link:\/\//i","$cgi_name?$udumys&lk=",$yakugo_str);
    return $yakugo_str;
  }
  else
  if($ichigyou == 0){
    $yakugo_str = str_replace("\r\n","<br>",$yakugo_str);
    $yakugo_str = str_replace("\n","<br>",$yakugo_str);
    $yakugo_str = str_replace("\r","<br>",$yakugo_str);
    if($yaku_cut || $mini_yaku_cut){
      $yakugo_str = yakugo_cut_syori_br($yakugo_str);
    }
  }
  else{
    $yakugo_str = str_replace("\r\n",",",$yakugo_str);
    $yakugo_str = str_replace("\n",",",$yakugo_str);
    $yakugo_str = str_replace("\r",",",$yakugo_str);
    if($yaku_cut || $mini_yaku_cut){
      $yakugo_str = yakugo_cut_syori($yakugo_str);
    }
  }
  return $yakugo_str;
}

Function hedda_yomikomi()
{
    #先頭にシーク
    #fseek($DATA, 0);
    #ファイル識別子読み込み
    global $DATA;
    global $data_version_code;
    global $rec_suu;
    global $index_kaishi_ichi;
    global $data_kaishi_ichi;

    $buf = fread($DATA,4);
    /* if (sizeof($buf) != 4) {
        print("Read ERROR Index file\n");
        fclose($DATA); 
        exit(1);
    }*/
    $version_code = unpack("V",$buf);
    if($version_code[1] != $data_version_code){
      print("EROR $file1 is not Nabeta CGI data file\n");
      fclose($DATA); 
      exit(1);
    }

    #レコード数読み込み(データ数)(見出し数)
    $buf = fread($DATA,4);
    /* if(strlen($buf)!= 4) {
        print("Read ERROR Index file\n");
        fclose($DATA); 
        exit(1);
    }*/
    $tmp = unpack("V",$buf);
    $rec_suu = $tmp[1];
    if($rec_suu == 0){
      print("EROR Data size zero.$file1\n");
      fclose($DATA); 
      exit(1);
    }
    #インデックス開始位置数読み込み
    $buf = fread($DATA,4);
    /* if(sizeof($buf) != 4) {
        print("Read ERROR Index file\n");
        fclose($DATA); 
        exit(1);
    }*/
    $tmp = unpack("V",$buf);
    $index_kaishi_ichi = $tmp[1];
    if($index_kaishi_ichi == 0){
      print("EROR Data size zero.$file1\n");
      fclose($DATA); 
      exit(1);
    }

    #データ開始位置数読み込み
    $buf = fread($DATA,4);
    /* if(sizeof($buf) != 4) {
        print("Read ERROR Index file\n");
        fclose($DATA); 
        exit(1);
    }*/
    $tmp = unpack("V",$buf);
    $data_kaishi_ichi = $tmp[1];
    if($data_kaishi_ichi == 0){
      print("EROR Data size zero.$file1\n");
      fclose($DATA); 
      exit(1);
    }
}

$nabeta_s1 = array();
$nabeta_s2 = array();
$nabeta_s1len = 0;
$nabeta_s2len = 0;

#鍋田辞書独自のソート順の文字列比較のための文字列を数字配列に変換。
#文字列先頭の7ビットのアスキーコードだけ順番が違う。
#NULLが最も小さく次にa-z,A-Z,、その他の7ビットの記号、後は通常のUnicode順
#もし、データが他のソート順であればここを変更しないといけない
Function nabeta_str2s1($sin)
{
  #$tmp = unpack("C*",$sin);
  global $nabeta_s1;
  global $nabeta_s1len;
  $mscd_str = str_split($sin);
  #$len = sizeof($mscd_str);
  $len = strlen($sin);
  $nabeta_s1len = $len;
  for($i=0;$i<$len;++$i){
    $cc = ord($mscd_str[$i]);
    #$tmp = unpack("C",$mscd_str[$i]);これでもよい
    #$cc = $tmp[1];
    if($i != 0){
      $nabeta_s1[$i] = $cc;
    }
    else
    if($cc >= 0x80){
      $nabeta_s1[$i] = $cc;
    }
    else
    if($cc == 0){
      #あり得ないパターン
      $nabeta_s1[$i] = $cc;
    }
    else
    if($cc <= 0x40){
      #記号1
      #53=ローマ字小文字26+ローマ字大文字26+NULL
      $nabeta_s1[$i] = $cc + 52 + 1;
    }
    else
    if($cc <= 0x5a){
      #A-Z
      #A=0x41
      $nabeta_s1[$i] = $cc - 0x41 + 26 + 1;
    }
    else
    if($cc <= 0x60){
      #記号2
      #53=ローマ字小文字26+ローマ字大文字26+NULL1
      $nabeta_s1[$i] = $cc - 0x5b + 52 + 0x40 + 1;
    }
    else
    if($cc <= 0x7a){
     #a-z
     #a=0x61
      $nabeta_s1[$i] = $cc - 0x61 + 1;
    }
    else
    if($cc <= 0x7f){
      #記号2
      #53=ローマ字小文字26+ローマ字大文字26+NULL1
      $nabeta_s1[$i] = $cc - 0x7b + 52 + 0x46 + 1;
    }
  }
}

Function nabeta_str2s2($sin)
{
  global $nabeta_s2;
  global $nabeta_s2len;
  #$tmp = unpack("C*",$sin);
  $mscd_str = str_split($sin);
  #$len = sizeof($mscd_str);
  $len = strlen($sin);
  $nabeta_s2len = $len;
  for($i=0;$i<$len;++$i){
    $cc = ord($mscd_str[$i]);
    #$tmp = unpack("C",$mscd_str[$i]);これでもよい
    #$cc = $tmp[1];
    if($i != 0){
      $nabeta_s2[$i] = $cc;
    }
    else
    if($cc >= 0x80){
      $nabeta_s2[$i] = $cc;
    }
    else
    if($cc == 0){
      #あり得ないパターン
      $nabeta_s2[$i] = $cc;
    }
    else
    if($cc <= 0x40){
      #記号1
      #53=ローマ字小文字26+ローマ字大文字26+NULL
      $nabeta_s2[$i] = $cc + 52 + 1;
    }
    else
    if($cc <= 0x5a){
      #A-Z
      #A=0x41
      $nabeta_s2[$i] = $cc - 0x41 + 26 + 1;
    }
    else
    if($cc <= 0x60){
      #記号2
      #53=ローマ字小文字26+ローマ字大文字26+NULL1
      $nabeta_s2[$i] = $cc - 0x5b + 52 + 0x40 + 1;
    }
    else
    if($cc <= 0x7a){
     #a-z
     #a=0x61
      $nabeta_s2[$i] = $cc - 0x61 + 1;
    }
    else
    if($cc <= 0x7f){
      #記号2
      #53=ローマ字小文字26+ローマ字大文字26+NULL1
      $nabeta_s2[$i] = $cc - 0x7b + 52 + 0x46 + 1;
    }
  }
  #my $n_str = pack "C*", $mscd; パックできない
}



#文字列を鍋田辞書独自のソート順に変換した数値配列の大小を比較
Function nabeta_strcmp()
{
  global $nabeta_s1;
  global $nabeta_s2;
  global $nabeta_s1len;
  global $nabeta_s2len;
  $len1 = $nabeta_s1len;
  $len2 = $nabeta_s2len;


  if($len1 > $len2){
    $lenns = $len2;
  }
  else{
    $lenns = $len1;
  }
  for($i=0;$i < $lenns;++$i){
    if($nabeta_s1[$i] > $nabeta_s2[$i]){
      #s1,左が大きい
      return 1;
    }
    else
    if($nabeta_s1[$i] < $nabeta_s2[$i]){
      #s1,左が小さい
      return -1;
    }
  }

  if($len1 > $len2){
    #s1,左が大きい
    return 1;
  }
  else
  if($len1 < $len2){
    #s1,左が小さい
    return -1;
  }
  else{
    #同じ
    return 0;
  }
}


if($keitai_minif == 0){
  $checked = "";
  if($nocasef){
    if($moto_oomoji == 0){
      $checked ="checked=\"checked\"";
    }
  }
  else{  
    if($moto_oomoji){
      $checked ="checked=\"checked\"";
    }
  }
  if($keitaif || $mobilef){
    $mcvs = conv2sjis("大文字");
  }
  else{
    if($nocasef){
      $mcvs = conv2sjis("大文字小文字区別");
    }
    else{
      $mcvs = conv2sjis("大文字小文字同一");
    }
  }

  print("<input name=\"om\" value=\"o\" $checked type=\"checkbox\">$mcvs\n");

  $checked = "";
  if($moto_ichigyou){
    $checked ="checked=\"checked\"";
  }
  print_us("$zenkaku_space<input name=\"ig\" value=\"i\" $checked type=\"checkbox\">");
  if($keitaif || $mobilef){
    $mcvs = conv2sjis("一行\n");
  }
  else{
    $mcvs = conv2sjis("訳語一行\n");
  }
  print $mcvs;

  $checked = "";
  if($moto_yaku_cut){
    $checked ="checked=\"checked\"";
  }
  if($mobilef){
    $mcvs = conv2sjis("訳語カット");
    print "$zenaku_space$zenaku_space<input name=\"yc\" value=\"y\" $checked type=\"checkbox\">$mcvs<br>\n";
  }
  else
  if($keitaif){
    //print "$zenaku_space<input name=\"yc\" value=\"y\" $checked $hh_checkbox>";
  }
  else{
    $mcvs = conv2sjis("一覧の訳語カット");
    print "$zenaku_space$zenaku_space<input name=\"yc\" value=\"y\" $checked type=\"checkbox\">$mcvs<br>\n";
  }
  
  
  $selected1kj = "";
  $selected2kj = "";
  $selected3kj = "";
  $selected4kj = "";
  $selected5kj = "";
  
  if(strcmp($smode,"sentou")==0 || strcmp($smode,"")==0){
    $selected1kj = "selected=\"selected\"";
  }
  else
  if(strcmp($smode,"bubun")==0){
    $selected2kj = "selected=\"selected\"";
  }
  else
  if(strcmp($smode,"kouhou")==0){
    $selected3kj = "selected=\"selected\"";
  }
  else
  if(strcmp($smode,"kanzen")==0){
    $selected4kj = "selected=\"selected\"";
  }
  else
  if(strcmp($smode,"seiki")==0){
    $selected5kj = "selected=\"selected\"";
  }


  $sentouh = conv2sjis("先頭一致");
  $bubunh = conv2sjis("部分一致");
  $kouhouh = conv2sjis("後方一致");
  $kanzenh = conv2sjis("完全一致");
  $seikih = conv2sjis("正規表現");

  print("<select name=\"sl\" size=\"1\">\n");
  print("<option value=\"sentou\" $selected1kj>$sentouh</option>\n");
  print("<option value=\"bubun\" $selected2kj>$bubunh</option>\n");
  print("<option value=\"kouhou\" $selected3kj>$kouhouh</option>\n");
  print("<option value=\"kanzen\" $selected4kj>$kanzenh</option>\n");
  print("<option value=\"seiki\" $selected5kj>$seikih</option>\n");
  print("</select>\n");

  
  $selected1kj = "";
  $selected2kj = "";
  $selected3kj = "";
  $selected4kj = "";
  $selected5kj = "";
  $selected6kj = "";
  $selected7kj = "";
  if($keitaif){
    if($keitai_minif){
      if($sjisf){
        $selected6kj = "selected=\"selected\"";
      }
      else{
        $selected5kj = "selected=\"selected\"";
      }
    } 
    else{
      if($sjisf){
        $selected4kj = "selected=\"selected\"";
      }
      else{
        $selected3kj = "selected=\"selected\"";
      }
    }
  }
  else
  if($mobilef){
    $selected2kj = "selected=\"selected\"";
  }
  else{
    $selected1kj = "selected=\"selected\"";
  }

  print("<select name=\"m\" size=\"1\" onchange=\"submit()\">\n");
  print("<option value=\"0\" $selected1kj>PC</option>\n");
  print("<option value=\"1\" $selected2kj>Smartphone</option>\n");
  print("<option value=\"2\" $selected3kj>Keitai wide UTF8</option>\n");
  print("<option value=\"3\" $selected4kj>Keitai wide SJIS</option>\n");
  print("<option value=\"4\" $selected5kj>Keitai mini UTF8</option>\n");
  print("<option value=\"5\" $selected6kj>Keitai mini SJIS</option>\n");
  print("</select>");
}
else{
  //携帯ミニ
  if($sjisf){
    $mcvs = "5";
  }
  else{
    $mcvs = "4";
  }
  print("<input value=\"$mcvs\" onclick=\"n_reset()\" type=\"hidden\" name=\"m\">\n");
}

if($keitaif == 0 && $use_ime_h[$dic_no]){
  $selected1kj = "";
  $selected2kj = "";
  $selected3kj = "";
  if($ime_mode_h[$dic_no] == 0){
    $selected1kj = 'checked="checked"';
  }
  else
  if($ime_mode_h[$dic_no] == 1){
    $selected2kj = 'checked="checked"';
  }
  else
  if($ime_mode_h[$dic_no] == 2){
    $selected3kj = 'checked="checked"';
  }
  print("<span id=\"rikiten\"></span>"); //ロシア語IMEの時の力点ボタンのエリア
  $jp_checked = "";
  if($mc_jp_no){
    $jp_checked = "checked";
  }
  if($ime_gengo_mode_h[$dic_no]){
    //韓国語以外
    print("<input name=\"jp\" value=\"1\" onclick=\"set_keyboard(this.checked);setcookie();\" type=\"checkbox\" $jp_checked>Japanese keyboard");
  }
  else{
    //韓国語は非表示のスタイル指定をする
    print("<input name=\"jp\" value=\"1\" $onclick=\"set_keyboard(this.checked);setcookie();\" type=\"checkbox\" $jp_chceked style=\"display:none\"");
    print "<br>";
  }
  print "<br>";
  print_us("<input name=\"im\" type=\"radio\" value=\"n\" $selected1kj onclick=\"set_ime(0);document.nabeta.it.focus();setcookie();\">IME OFF$zenkaku_space");
  print_us("<input name=\"im\" type=\"radio\" value=\"r\" $selected2kj onclick=\"set_ime(1);document.nabeta.it.focus();setcookie();\">Roma IME$zenkaku_space");
  print_us("<input name=\"im\" type=\"radio\" value=\"k\" $selected3kj onclick=\"set_ime(2);document.nabeta.it.focus();setcookie();\">Normal IME$zenkaku_space");
  $s = "";
  if($ime_gengo_mode_h[$dic_no] != 3){
    //エスペラント以外はスクリーンキーボードがある
    $jp_checked = "";
    if($mc_sc_no){
      $jp_checked = "checked";
    }
    print_us("<input name=\"sc_keymap\" onclick=\"sckeyboard_on();setcookie()\" type=\"checkbox\" $jp_checked>Screen keyboard<br>");
    if($mc_sc_no){

      if($ime_gengo_mode_h[$dic_no] == 0){
        $s = '<img src="koreakeyboard.jpeg" border="1"><br>';
      }
      else
      if($ime_gengo_mode_h[$dic_no] == 1){
        $s = '<img src="thaikeyboard.jpeg" border="1"><br>';
      }
      else
      if($ime_gengo_mode_h[$dic_no] == 2){
        $s = '<img src="russiakeyboard.jpeg" border="1"><br>';
      }
      else{
        $s = "";
      }
    }
  }
  print("<span id=\"screenkeyboard\">$s</span>");
  //print('<br><span id="nbmsg"></span>'); //for debug
  //print('<br><span id="nbmsg3"></span>'); //for debug
  //print('<br><span id="mspmsg"></span>'); //for debug
}
else
if($keitaif == 0 && $use_ime_h[$dic_no] == 0){
  print('<input type="hidden" name="im" value="n">');
}

  if($kasiramoji_link){
    //ローマ字の頭文字で検索するリンクを付ける。
    //タイ文字などその他の文字に変える場合は自分で変えて欲しい。
  if($keitai_utf8f == 0 && $keitaif == 0 && $mobilef == 0){
  $kc_pm = $kc_pm . "&jp=$mc_jp_no";
  if($mobilef){
    $kc_pm = $kc_pm . "&m=1";
  }
  else
  if($keitai_utf8f){
    if($keitai_minif){
      $kc_pm = $kc_pm . "&m=4";
    }
    else{
      $kc_pm = $kc_pm . "&m=2";
    }
  }
  else
  if($keitaif){
    if($keitai_minif){
      $kc_pm = $kc_pm . "&m=5";
    }
    else{
      $kc_pm = $kc_pm . "&m=3";
    }
  }
  else{
    $kc_pm = $kc_pm . "&m=0";
  }

  print_us("　<a href=\"$cgi_name?dd=$dic_no&fs=$font_size&it=a&hk=$hyouji_kensuu_str&rb=t&sl=sentou&$kc_pm\">a</a>　");
  print_us("<a href=\"$cgi_name?dd=$dic_no&fs=$font_size&it=b&hk=$hyouji_kensuu_str&rb=t&sl=sentou&$kc_pm\">b</a>　");
  print_us("<a href=\"$cgi_name?dd=$dic_no&fs=$font_size&it=c&hk=$hyouji_kensuu_str&rb=t&sl=sentou&$kc_pm\">c</a>　");
  print_us("<a href=\"$cgi_name?dd=$dic_no&fs=$font_size&it=d&hk=$hyouji_kensuu_str&rb=t&sl=sentou&$kc_pm\">d</a>　");
  print_us("<a href=\"$cgi_name?dd=$dic_no&fs=$font_size&it=e&hk=$hyouji_kensuu_str&rb=t&sl=sentou&$kc_pm\">e</a>　");
  print_us("<a href=\"$cgi_name?dd=$dic_no&fs=$font_size&it=f&hk=$hyouji_kensuu_str&rb=t&sl=sentou&$kc_pm\">f</a>　");
  print_us("<a href=\"$cgi_name?dd=$dic_no&fs=$font_size&it=g&hk=$hyouji_kensuu_str&rb=t&sl=sentou&$kc_pm\">g</a>　");
  print_us("<a href=\"$cgi_name?dd=$dic_no&fs=$font_size&it=h&hk=$hyouji_kensuu_str&rb=t&sl=sentou&$kc_pm\">h</a>　");
  print_us("<a href=\"$cgi_name?dd=$dic_no&fs=$font_size&it=i&hk=$hyouji_kensuu_str&rb=t&sl=sentou&$kc_pm\">i</a>　");
  print_us("<a href=\"$cgi_name?dd=$dic_no&fs=$font_size&it=j&hk=$hyouji_kensuu_str&rb=t&sl=sentou&$kc_pm\">j</a>　");
  print_us("<a href=\"$cgi_name?dd=$dic_no&fs=$font_size&it=k&hk=$hyouji_kensuu_str&rb=t&sl=sentou&$kc_pm\">k</a>　");
  print_us("<a href=\"$cgi_name?dd=$dic_no&fs=$font_size&it=l&hk=$hyouji_kensuu_str&rb=t&sl=sentou&$kc_pm\">l</a>　");
  print_us("<a href=\"$cgi_name?dd=$dic_no&fs=$font_size&it=m&hk=$hyouji_kensuu_str&rb=t&sl=sentou&$kc_pm\">m</a>　");
  print_us("<a href=\"$cgi_name?dd=$dic_no&fs=$font_size&it=n&hk=$hyouji_kensuu_str&rb=t&sl=sentou&$kc_pm\">n</a>　");
  print_us("<a href=\"$cgi_name?dd=$dic_no&fs=$font_size&it=o&hk=$hyouji_kensuu_str&rb=t&sl=sentou&$kc_pm\">o</a>　");
  print_us("<a href=\"$cgi_name?dd=$dic_no&fs=$font_size&it=p&hk=$hyouji_kensuu_str&rb=t&sl=sentou&$kc_pm\">p</a>　");
  print_us("<a href=\"$cgi_name?dd=$dic_no&fs=$font_size&it=q&hk=$hyouji_kensuu_str&rb=t&sl=sentou&$kc_pm\">q</a>　");
  print_us("<a href=\"$cgi_name?dd=$dic_no&fs=$font_size&it=r&hk=$hyouji_kensuu_str&rb=t&sl=sentou&$kc_pm\">r</a>　");
  print_us("<a href=\"$cgi_name?dd=$dic_no&fs=$font_size&it=s&hk=$hyouji_kensuu_str&rb=t&sl=sentou&$kc_pm\">s</a>　");
  print_us("<a href=\"$cgi_name?dd=$dic_no&fs=$font_size&it=t&hk=$hyouji_kensuu_str&rb=t&sl=sentou&$kc_pm\">t</a>　");
  print_us("<a href=\"$cgi_name?dd=$dic_no&fs=$font_size&it=u&hk=$hyouji_kensuu_str&rb=t&sl=sentou&$kc_pm\">u</a>　");
  print_us("<a href=\"$cgi_name?dd=$dic_no&fs=$font_size&it=v&hk=$hyouji_kensuu_str&rb=t&sl=sentou&$kc_pm\">v</a>　");
  print_us("<a href=\"$cgi_name?dd=$dic_no&fs=$font_size&it=w&hk=$hyouji_kensuu_str&rb=t&sl=sentou&$kc_pm\">w</a>　");
  print_us("<a href=\"$cgi_name?dd=$dic_no&fs=$font_size&it=x&hk=$hyouji_kensuu_str&rb=t&sl=sentou&$kc_pm\">x</a>　");
  print_us("<a href=\"$cgi_name?dd=$dic_no&fs=$font_size&it=y&hk=$hyouji_kensuu_str&rb=t&sl=sentou&$kc_pm\">y</a>　");
  print_us("<a href=\"$cgi_name?dd=$dic_no&fs=$font_size&it=z&hk=$hyouji_kensuu_str&rb=t&sl=sentou&$kc_pm\">z</a>　");

  print_us("<a href=\"$cgi_name?dd=$dic_no&fs=$font_size&it=A&hk=$hyouji_kensuu_str&rb=t&sl=sentou&$kc_pm\">A</a>　");
  print_us("<a href=\"$cgi_name?dd=$dic_no&fs=$font_size&it=B&hk=$hyouji_kensuu_str&rb=t&sl=sentou&$kc_pm\">B</a>　");
  print_us("<a href=\"$cgi_name?dd=$dic_no&fs=$font_size&it=C&hk=$hyouji_kensuu_str&rb=t&sl=sentou&$kc_pm\">C</a>　");
  print_us("<a href=\"$cgi_name?dd=$dic_no&fs=$font_size&it=D&hk=$hyouji_kensuu_str&rb=t&sl=sentou&$kc_pm\">D</a>　");
  print_us("<a href=\"$cgi_name?dd=$dic_no&fs=$font_size&it=E&hk=$hyouji_kensuu_str&rb=t&sl=sentou&$kc_pm\">E</a>　");
  print_us("<a href=\"$cgi_name?dd=$dic_no&fs=$font_size&it=F&hk=$hyouji_kensuu_str&rb=t&sl=sentou&$kc_pm\">F</a>　");
  print_us("<a href=\"$cgi_name?dd=$dic_no&fs=$font_size&it=G&hk=$hyouji_kensuu_str&rb=t&sl=sentou&$kc_pm\">G</a>　");
  print_us("<a href=\"$cgi_name?dd=$dic_no&fs=$font_size&it=H&hk=$hyouji_kensuu_str&rb=t&sl=sentou&$kc_pm\">H</a>　");
  print_us("<a href=\"$cgi_name?dd=$dic_no&fs=$font_size&it=I&hk=$hyouji_kensuu_str&rb=t&sl=sentou&$kc_pm\">I</a>　");
  print_us("<a href=\"$cgi_name?dd=$dic_no&fs=$font_size&it=J&hk=$hyouji_kensuu_str&rb=t&sl=sentou&$kc_pm\">J</a>　");
  print_us("<a href=\"$cgi_name?dd=$dic_no&fs=$font_size&it=K&hk=$hyouji_kensuu_str&rb=t&sl=sentou&$kc_pm\">K</a>　");
  print_us("<a href=\"$cgi_name?dd=$dic_no&fs=$font_size&it=L&hk=$hyouji_kensuu_str&rb=t&sl=sentou&$kc_pm\">L</a>　");
  print_us("<a href=\"$cgi_name?dd=$dic_no&fs=$font_size&it=M&hk=$hyouji_kensuu_str&rb=t&sl=sentou&$kc_pm\">M</a>　");
  print_us("<a href=\"$cgi_name?dd=$dic_no&fs=$font_size&it=N&hk=$hyouji_kensuu_str&rb=t&sl=sentou&$kc_pm\">N</a>　");
  print_us("<a href=\"$cgi_name?dd=$dic_no&fs=$font_size&it=O&hk=$hyouji_kensuu_str&rb=t&sl=sentou&$kc_pm\">O</a>　");
  print_us("<a href=\"$cgi_name?dd=$dic_no&fs=$font_size&it=P&hk=$hyouji_kensuu_str&rb=t&sl=sentou&$kc_pm\">P</a>　");
  print_us("<a href=\"$cgi_name?dd=$dic_no&fs=$font_size&it=Q&hk=$hyouji_kensuu_str&rb=t&sl=sentou&$kc_pm\">Q</a>　");
  print_us("<a href=\"$cgi_name?dd=$dic_no&fs=$font_size&it=R&hk=$hyouji_kensuu_str&rb=t&sl=sentou&$kc_pm\">R</a>　");
  print_us("<a href=\"$cgi_name?dd=$dic_no&fs=$font_size&it=S&hk=$hyouji_kensuu_str&rb=t&sl=sentou&$kc_pm\">S</a>　");
  print_us("<a href=\"$cgi_name?dd=$dic_no&fs=$font_size&it=T&hk=$hyouji_kensuu_str&rb=t&sl=sentou&$kc_pm\">T</a>　");
  print_us("<a href=\"$cgi_name?dd=$dic_no&fs=$font_size&it=U&hk=$hyouji_kensuu_str&rb=t&sl=sentou&$kc_pm\">U</a>　");
  print_us("<a href=\"$cgi_name?dd=$dic_no&fs=$font_size&it=V&hk=$hyouji_kensuu_str&rb=t&sl=sentou&$kc_pm\">V</a>　");
  print_us("<a href=\"$cgi_name?dd=$dic_no&fs=$font_size&it=W&hk=$hyouji_kensuu_str&rb=t&sl=sentou&$kc_pm\">W</a>　");
  print_us("<a href=\"$cgi_name?dd=$dic_no&fs=$font_size&it=X&hk=$hyouji_kensuu_str&rb=t&sl=sentou&$kc_pm\">X</a>　");
  print_us("<a href=\"$cgi_name?dd=$dic_no&fs=$font_size&it=Y&hk=$hyouji_kensuu_str&rb=t&sl=sentou&$kc_pm\">Y</a>　");
  print_us("<a href=\"$cgi_name?dd=$dic_no&fs=$font_size&it=Z&hk=$hyouji_kensuu_str&rb=t&sl=sentou&$kc_pm\">Z</a>　");
  }
  }

  if($keitaif == 0){
    print("</form><nobr><form name =\"nabeta2\">");
  }

  if(strcmp($input_tango,"")!=0 && $randomf == 0 && $keitaif == 0){
    print("<input $hh_text name=\"ntext\" size=\"50\" readonly>\n");
  }
  print("</form><form name =\"nabeta3\">");


if(strcmp($chosakuken,$data_chosakukens)==0){
  global $yaku_cut;
  if(($DATA = fopen($file1,"rb"))==FALSE){
    print("Data file $file1 Open Error(read only)\n");
    exit(1);
  } 
  hedda_yomikomi();

  $yakugo = "";
  while (1){
    $c = fgetc($DATA);
    if(strcmp($c,"\0")==0){
      break;   
    }       
    $yakugo = $yakugo . $c; 
  }

  $yaku_cut = 0;
  $yakugo = yakugo_syori($yakugo);

  print("<br>$yakugo\n");
  print("</form>");
  print("</body></html>\n");
  fclose($DATA); 
  exit(2);
}


  #単語クリック時に渡すパラメーターセット
  $zen_pm = "";

  if($nocasef){
    if($moto_oomoji == 0){
      $zen_pm = "&om=o";//大文字小文字区別する
    }
  }
  else{
    if($moto_oomoji){
      $zen_pm = "&om=o";//大文字小文字区別する
    }
  }
  if($moto_ichigyou){
    $zen_pm = $zen_pm . "&ig=i";
  }
  if($yaku_cut){
    $zen_pm = $zen_pm . "&yc=y";
  }
  $zen_pm = $zen_pm . "&hk=$hyouji_kensuu_str";
  $zen_pm = $zen_pm . "&rb=$tymode";
  $zen_pm = $zen_pm . "&sl=$smode";
  $zen_pm = $zen_pm . "&dd=$dic_no";

  $zen_pm = $zen_pm . "&jp=$mc_jp_no";

  if($mobilef){
    $zen_pm = $zen_pm . "&m=1";
  }
  else
  if($keitai_utf8f){
    if($keitai_minif){
      $zen_pm = $zen_pm . "&m=4";
    }
    else{
      $zen_pm = $zen_pm . "&m=2";
    }
  }
  else
  if($keitaif){
    if($keitai_minif){
      $zen_pm = $zen_pm . "&m=5";
    }
    else{
      $zen_pm = $zen_pm . "&m=3";
    }
  }
  else{
    $zen_pm = $zen_pm . "&m=0";
  }

  $ny_tango = conv2utf8($moto_input_tango);
  $ny_tango = urlencode($ny_tango);

  $zen_pm = $zen_pm . "&ut=$ny_tango";

$s_rc = 0;
$misf = 0;
$m_ichi = 0;
if($randomf || strcmp($input_tango,"")==0){
  //ランダム
  $randomf = 1;
  if(($DATA = fopen($file1,"rb"))==FALSE){
    print("Data file $file1 Open Error(read only)\n");
    exit(1);
  } 

  #ヘッダ読み込み
  hedda_yomikomi();
  if($rec_suu >= 1){
    //データ件数が一件以上。
    table_hyouji();
    $ransuu = rand(0,$rec_suu-1);
    fseek($DATA, $ransuu * 4 + $index_kaishi_ichi);
    $buf = fread($DATA,4);
    /* if(sizeof($buf) != 4) {
        print("Read ERROR Index file\n");
        fclose($DATA); 
        exit(1);
    }*/
    $tmp = unpack("V",$buf);
    $data_adr = $tmp[1];

    fseek($DATA, $data_adr + $data_kaishi_ichi);
    $tangos = "";
    while(1){
      $c = fgetc($DATA);
      if(strcmp($c,"\0")==0){
        break;   
      }       
      $tangos = $tangos . $c; 
    }

    if(strcmp($tangos,"")==0){
      #単語名がない。エラー
    }
    else{
      $yakugo = "";
      while (1){
        $c = fgetc($DATA);
        if(strcmp($c,"\0")==0){
          break;
        }
        $yakugo = $yakugo . $c; 
      }
      $tangos = tangos_syori($tangos);
      $yakugo = yakugo_syori($yakugo);
      table_hyouji2();
    }
    print("</table>");
  }
  fclose($DATA);

  $hkens = conv2sjis("ランダム表示");
  if($keitaif){
    print("<br>");
  }
  print ("$hkens<br>\n"); 
}
else
if(strcmp($input_tango,"")){
#もし検索文字が入力されていれば

  $input_tango = conv2utf8($input_tango);

  //sara am 変換
  $input_tango = str_replace("ํา", "ำ", $input_tango);
  $input_tango = str_replace("ํ่า", "่ำ", $input_tango);
  $input_tango = str_replace("ํ้า","้ำ", $input_tango);
  $input_tango = str_replace("ํ๋า","๋ำ", $input_tango);
  $input_tango = str_replace("ํ๊า","๊ำ", $input_tango);

  if(strcmp($tymode,"t")==0 || $link_hyouji){//単語
  if(strcmp($smode,"sentou")==0 && $link_hyouji == 0){
    #先頭一致
    if(($DATA = fopen($file1,"rb"))==FALSE){
      print("Data file $file1 Open Error(read only)\n");
      exit(1);
    } 

    $len = strlen($input_tango);
    $input_len = $len;
    #ヘッダ読み込み
    hedda_yomikomi();
    table_hyouji();

    #大文字小文字オプション有り且つローマ字の入力有れば全ループ
    #大文字小文字オプション無しでバイナリサーチ
    $left = 0;
    $right = $rec_suu-1;
    $icchi = 0;
    $sentou_cnt = 0;
    $k_cnt = 0;
    $z_cnt = 0;
    if($oomoji == 0 && $nextf == 0){
      nabeta_str2s2($input_tango);
    }

    if($nextf){
      $sentou_cnt = $next_rc; 
    }

    //2014/2/20
    if($pmax > 0){
      $sentou_cnt = $pagez[$page_no];
    }

    $icchi_kensuuf = 0; 
    while(1){
      if($oomoji || $nextf){
        #大文字小文字オプション
        if($sentou_cnt < $rec_suu){
        }
        else{
          break;
        }
      }
      else{
        #大文字小文字オプション無し
        if($left <= $right){
        }
        else{
          break;
        }
      }

      if($oomoji || $next_rc){
        $mid = $sentou_cnt; 
      }
      else{
        $mid = intval(($left + $right) / 2); 
      }
      fseek($DATA, $mid * 4 + $index_kaishi_ichi);
      $buf = fread($DATA,4);
      /* if(sizeof($buf) != 4) {
          print("Read ERROR Index file\n");
          fclose($DATA); 
          exit(1);
      }*/
      $tmp = unpack("V",$buf);
      $data_adr = $tmp[1];

      fseek($DATA, $data_adr + $data_kaishi_ichi);
      $tangos = "";
      while (1){
        $c = fgetc($DATA);
        if(strcmp($c,"\0")==0){
          break;   
        }       
        $tangos = $tangos . $c; 
      }

      $cmp_tango = substr($tangos,0,$len);

      if($oomoji || $nextf){
        $cmp_tango = strtolower($cmp_tango);
      }
      else{
        nabeta_str2s1($cmp_tango);
      }

      if($oomoji == 0 || $nextf == 0){
        $cmp = nabeta_strcmp();
      }

      $icchi = 0;
      if($nextf && $oomoji == 0){
        if(strcmp($cmp_tango,$input_tango)==0){
          $icchi = 1;
        }
	else{
          break;
	}
      }
      else
      if($oomoji){
        if($sentou_romaji){
          $sentoumoji = substr($tangos,0,1);
	  $sort_mode = 1;
	  if($sort_mode == 1){
            if(strtoupper($sentoumoji)===$sentoumoji){
              $at_o = strtoupper($atama_str);
              if(strcmp($sentoumoji,$at_o) > 0){
                break;
              } 
            } 
	  }
	  else{
            if(strtolower($sentoumoji)===$sentoumoji){
              $at_k = strtolower($atama_str);
              if(strcmp($sentoumoji,$at_k) > 0){
                break;
              } 
            } 
	  }
        }
        if(strcmp($cmp_tango,$input_tango)==0){
          $icchi = 1;
        }
      }
      #else if($cmp_tango eq $input_tango){}
      else
      if($cmp == 0){
        #データの先頭部分が一致
        $icchi = 1;
        $nn = $mid;
      }
      #else if($cmp_tango lt $input_tango){}
      else
      if($cmp < 0){
        #文字列比較 tangos < input_tango
        # midより左側にinput_tangoは存在しない
        $left = $mid + 1;
        #contunue;
      }
      else{
        # midより右側にinput_tangoは存在しない
        $right = $mid - 1;
        #contunue;
      }

      if($oomoji == 0 && $icchi && $nextf == 0){
        #大文字小文字オプション無しの先頭一致
        if(strcmp($tangos,$input_tango)){
          #バックする
          $nn = $nn -1;
          while(1){
            if($nn < 0){
              $nn = 0;
              break;
            }
            fseek($DATA, $nn * 4 + $index_kaishi_ichi);
            $buf = fread($DATA,4);
            /* if(sizeof($buf) != 4) {
                print("Read ERROR Index file\n");
                fclose($DATA); 
                exit(1);
	    }*/
            $tmp = unpack("V",$buf);
            $data_adr = $tmp[1];
            fseek($DATA, $data_adr + $data_kaishi_ichi);
            $tangos = "";
            while (1){
              $c = fgetc($DATA);
              if(strcmp($c,"\0")==0){
                break;   
              }       
              $tangos = $tangos . $c; 
            }
            $cmp_tango = substr($tangos,0,$len);
            nabeta_str2s1($cmp_tango);
            $cmp = nabeta_strcmp();
            #if($cmp_tango lt $input_tango){}
            if($cmp < 0){
              #先頭一致しない。小さいので一個たして先頭一致の始めにする
              ++$nn;
	      $s_rc = $nn;//一致する先頭レコード
              break;
            #{}else if($cmp_tango eq $input_tango){}
            #}else if($tangos eq $input_tango){
              #単語が入力と完全一致
              #break;
            }
            else{
              #先頭一致しない。大きいのでバックのループを続ける
              --$nn;
            }
          }#バックループ終わり
        }#バック終わり

        #先頭一致の開始位置からループ
        while(1){
          fseek($DATA, $nn * 4 + $index_kaishi_ichi);
          $buf = fread($DATA,4);
          /* if(sizeof($buf) != 4) {
              print("Read ERROR Index file\n");
              fclose($DATA); 
              exit(1);
	  }*/
          $tmp = unpack("V",$buf);
          $data_adr = $tmp[1];
          fseek($DATA, $data_adr + $data_kaishi_ichi);
          $tangos = "";
          while (1){
            $c = fgetc($DATA);
            if(strcmp($c,"\0")==0){
              break;   
            }       
            $tangos = $tangos . $c; 
          }

          #この比較は大小関係なく、先頭一致かどうかなので普通の関数で比較
	  
          if(strncmp($tangos,$input_tango,$input_len) == 0){
            #先頭一致(大文字区別有り)
            if($icchi_kensuuf == 0){ 
              $yakugo = "";
              if($keitaif == 0){
                while (1){
                  $c = fgetc($DATA);
                  if(strcmp($c,"\0")==0){
                    break;
                  }
                  $yakugo = $yakugo . $c; 
                }
                $yakugo = yakugo_syori($yakugo);
              }

              $tangos = tangos_syori($tangos);
              table_hyouji2();
              ++$k_cnt;
	    }
            else{
              ++$z_cnt;
            }

	    if($icchi_kensuu_mode){
              #一致件数を求めるモード
              if($k_cnt >= $dmax){
                #一致件数を求めるためにループから抜けない
                #次から単語/訳語は非表示で一致件数を求めるためだけにループ
                if($icchi_kensuuf == 0){
                  $z_cnt = $k_cnt;
                }
		$icchi_kensuuf = 1; 
              }
            }
	    else
            if($k_cnt >= $dmax){
              break;
            }
          }
          else{
            break;
          }
          ++$nn;
          if($nn >= $rec_suu){
            break;
          }
        }#先頭一致開始点からのループ終了
        break;
      }
      else
      if(($nextf || $oomoji == 1) && $icchi){
        #大文字小文字オプションの先頭一致
          fseek($DATA, $sentou_cnt * 4 + $index_kaishi_ichi);
          $buf = fread($DATA,4);
          /* if(sizeof($buf != 4) {
              print("Read ERROR Index file\n");
              fclose($DATA); 
              exit(1);
	  }*/
          $tmp = unpack("V",$buf);
          $data_adr = $tmp[1];
          fseek($DATA, $data_adr + $data_kaishi_ichi);
          $tangos = "";
          while (1){
            $c = fgetc($DATA);
            if(strcmp($c,"\0")==0){
              break;   
            }       
            $tangos = $tangos . $c; 
          }
          $komoji_tangos = strtolower($tangos);
          if(strncmp($komoji_tangos,$input_tango,$input_len) == 0){
            #先頭一致(大文字区別無し)
            if($icchi_kensuuf == 0){ 
              if($misf == 0){
                $m_ichi = $sentou_cnt;
                $misf = 1;
              }
              $next_rc_tugi = $sentou_cnt + 1;
              $yakugo = "";
              if($keitaif == 0){
                while (1){
                  $c = fgetc($DATA);
                  if(strcmp($c,"\0")==0){
                    break;
                  }
                  $yakugo = $yakugo . $c; 
                }
                $yakugo = yakugo_syori($yakugo);
              }
              $tangos = tangos_syori($tangos);
              table_hyouji2();
              ++$k_cnt;

            }
            else{
              ++$z_cnt;
            }

	    if($icchi_kensuu_mode){
              #一致件数を求めるモード
              if($k_cnt >= $dmax){
                #一致件数を求めるためにループから抜けない
                #次から単語/訳語は非表示で一致件数を求めるためだけにループ
                if($icchi_kensuuf == 0){
                  $z_cnt = $k_cnt;
                }
		$icchi_kensuuf = 1; 
              }
            }
	    else
            if($k_cnt >= $dmax){
              break;
            }
          }
      }
      if($oomoji || $nextf){
        ++$sentou_cnt;
      }
    }
    print("</table>");
    if($k_cnt == 0){
      $hkens = conv2sjis("該当無し");
      if($keitaif == 0){
        print("<script type=\"text/javascript\">\n<!--\ndocument.nabeta2.ntext.value=\"$hkens\"\n-->\n</script>\n");
      }
      if($keitaif){
        print("<br>");
      }
      print ("$hkens<br>\n"); 
    }
    else
    if($icchi_kensuu_mode == 1){
      if($z_cnt <  $k_cnt){
        $z_cnt = $k_cnt;
      }
      if($next_rc == 0){
        $hkens = "$z_cnt" . "件中" .  "$k_cnt" . "件表示";
      }
      else{
        if($oomoji){
          $mc = $page_no * $dmax + 1;
          $hkens = "$moto_z_cnt" . "件中" .  $mc . "～" . ($mc+$k_cnt-1) . "番目の" . "$k_cnt" . "件表示";
        }
        else{
          $mc = $next_rc - $moto_k_ichi + 1;
          $hkens = "$moto_z_cnt" . "件中" .  $mc . "～" . ($mc+$k_cnt-1) . "番目の" . "$k_cnt" . "件表示";
        }
      }
      $hkens = conv2sjis($hkens);

      if($keitaif == 0){
        print("<script type=\"text/javascript\">\n<!--\ndocument.nabeta2.ntext.value=\"$hkens\"\n-->\n</script>\n");
      }
      if($keitaif){
        print("<br>");
      }
      print("$hkens<br>\n");
    }
    else{
      $hkens = "$k_cnt" . conv2sjis("件表示");
      if($keitaif == 0){
        print("<script type=\"text/javascript\">\n<!--\ndocument.nabeta2.ntext.value=\"$hkens\"\n-->\n</script>\n");
      }
      if($keitaif){
        print("<br>");
      }
      print ("$hkens<br>\n"); 
    }
    #sentou end
    fclose($DATA);

    if($oomoji == 0){
      $next_rc_tugi = $next_rc + $s_rc + $k_cnt;
    }
  }
  else
  if(strcmp($smode,"kanzen")==0 || $link_hyouji == 1){
    if(($DATA = fopen($file1,"rb"))==FALSE){
      print("Data file $file1 Open Error(read only)\n");
      exit(1);
    } 

    $len = strlen($input_tango);
    
    #ヘッダ読み込み
    hedda_yomikomi();
    table_hyouji();

    #大文字小文字オプション有り且つローマ字の入力有れば全ループ
    #大文字小文字オプション無しでバイナリサーチ
    $left = 0;
    $right = $rec_suu-1;
    $icchi = 0;
    #kanzen
    $kanzen_cnt = 0;
    $k_cnt = 0;
    if($oomoji == 0){
      nabeta_str2s2($input_tango);
    }
    while(1){
      if($oomoji){
        #大文字小文字オプション有り
        if($kanzen_cnt < $rec_suu){
        }
        else{
          break;
        }
      }
      else{
        #大文字小文字オプション無し
        if($left <= $right){
        }
        else{
          break;
        }
      }
      if($oomoji){
        $mid = $kanzen_cnt; 
      }
      else{
        $mid = intval(($left + $right) / 2); 
      }
      fseek($DATA, $mid * 4 + $index_kaishi_ichi);
      $buf = fread($DATA,4);
      /* if(sizeof($buf) != 4) {
          print("Read ERROR Index file\n");
          fclose($DATA); 
          exit(1);
      }*/
      $tmp = unpack("V",$buf);
      $data_adr = $tmp[1];

      fseek($DATA, $data_adr + $data_kaishi_ichi);
      $tangos = "";
      while (1){
        $c = fgetc($DATA);
        if(strcmp($c,"\0")==0){
          break;
        }       
        $tangos = $tangos . $c; 
      }
      if($oomoji == 0){
        nabeta_str2s1($tangos);
        $cmp = nabeta_strcmp();
      }
      $icchi = 0;
      if($oomoji){
        #大文字小文字オプション有り
        if($sentou_romaji){
          $sentoumoji = substr($tangos,0,1);
          $at_k = strtolower($atama_str);
          $at_o = strtoupper($atama_str);
          if(strcmp($sentoumoji,$at_k) > 0 && strcmp($sentoumoji,$at_o) > 0){
            break;
          } 
        }

        $komoji_tangos = strtolower($tangos);
        if(strcmp($komoji_tangos,$input_tango)==0){
          #大文字小文字を区別せずデータが一致
          $icchi = 1;
        }
      }
      else
      if($cmp == 0){
        #データが完全一致
        $icchi = 1;
      }
      else
      if($cmp < 0){
        #文字列比較 tangos < input_tango
        # midより左側にinput_tangoは存在しない
        $left = $mid + 1;
      }
      else{
        # midより右側にinput_tangoは存在しない
        $right = $mid - 1;
      }

      if(strcmp($tangos,"")==0){
      }
      else
      if($icchi == 1){
        if($icchi_kensuuf == 0){ 
          $yakugo = "";
          if($keitaif == 0 || $link_hyouji){
            while (1){
              $c = fgetc($DATA);
              if(strcmp($c,"\0")==0){
                break;
              }
              $yakugo = $yakugo . $c; 
            }
            $yakugo = yakugo_syori($yakugo);
          }

          $tangos = tangos_syori($tangos);
          table_hyouji2();
          ++$k_cnt;
        }
        else{
          ++$z_cnt;
        }

        if($oomoji == 0){
          break;
        }
        if($icchi_kensuu_mode){
          #一致件数を求めるモード
          if($k_cnt >= $dmax){
            #一致件数を求めるためにループから抜けない
            #次から単語/訳語は非表示で一致件数を求めるためだけにループ
            if($icchi_kensuuf == 0){
              $z_cnt = $k_cnt;
            }
            $icchi_kensuuf = 1; 
          }
        }
        else
        if($k_cnt >= $dmax){
          break;
        }
      }
      if($oomoji){
        ++$kanzen_cnt;
      }
    }
    print("</table>");
    if($k_cnt == 0){
      $hkens = conv2sjis("該当無し");
      if($keitaif == 0){
        print("<script type=\"text/javascript\">\n<!--\ndocument.nabeta2.ntext.value=\"$hkens\"\n-->\n</script>\n");
      }
      if($keitaif){
        print("<br>");
      }
      print ("$hkens<br>\n"); 
    }
    else
    if($link_hyouji){
      $hkens = conv2sjis("選択表示");
      if($keitaif == 0){
        print("<script type=\"text/javascript\">\n<!--\ndocument.nabeta2.ntext.value=\"$hkens\"\n-->\n</script>\n");
      }
      if($keitaif){
        print("<br>");
      }
      print ("$hkens<br>\n"); 
    }
    else
    if($icchi_kensuu_mode == 1){
      if($z_cnt <  $k_cnt){
        $z_cnt = $k_cnt;
      }
      $hkens = "$z_cnt" . conv2sjis("件中") .  "$k_cnt" . conv2sjis("件表示");
      if($keitaif == 0){
        print("<script type=\"text/javascript\">\n<!--\ndocument.nabeta2.ntext.value=\"$hkens\"\n-->\n</script>\n");
      }
      if($keitaif){
        print("<br>");
      }
      print ("$hkens<br>\n"); 
    }
    else{
      $hkens = "$k_cnt" . conv2sjis("件表示");
      if($keitaif == 0){
        print("<script type=\"text/javascript\">\n<!--\ndocument.nabeta2.ntext.value=\"$hkens\"\n-->\n</script>\n");
      }
      if($keitaif){
        print("<br>");
      }
      print ("$hkens<br>\n"); 
    }
    fclose($DATA);
    #kanzen end
  }
  else
  if(strcmp($smode,"bubun")==0){
    #部分一致検索
    $icchi_kensuu_mode = 0;//時間かかるからやめた

    if(($DATA = fopen($file1,"rb"))==FALSE){
      print("Data file $file1 Open Error(read only)\n");
      exit(1);
    } 

    $len = strlen($input_tango);

    #ヘッダ読み込み
    hedda_yomikomi();
    table_hyouji();

    #全数ループ
    #bubun
    $k_cnt = 0;
    for($i=0;$i<$rec_suu;++$i){
      fseek($DATA, $i * 4 + $index_kaishi_ichi);
      $buf = fread($DATA,4);
      /* if(sizeof($buf) != 4) {
          print("Read ERROR Index file\n");
          fclose($DATA); 
          exit(1);
      }*/
      $tmp = unpack("V",$buf);
      $data_adr = $tmp[1];

      fseek($DATA, $data_adr + $data_kaishi_ichi);
      $tangos = "";
      while (1){
        $c = fgetc($DATA);
        if(strcmp($c,"\0")==0){
          break;   
        }       
        $tangos = $tangos . $c; 
      }
      $bubun_icchi = 0;
      if(strcmp($tangos,"")==0){
      }
      else{
        if($oomoji){
          $tangos_komoji = strtolower($tangos);
          if(strstr($tangos_komoji,$input_tango)){
            $bubun_icchi = 1;
          }
        }
        else{
          if(strstr($tangos,$input_tango)){
            $bubun_icchi = 1;
          }
        }
      }
      if($bubun_icchi){
        if($icchi_kensuuf == 0){ 
          $yakugo = "";
          if($keitaif == 0){
            while (1){
              $c = fgetc($DATA);
              if(strcmp($c,"\0")==0){
                break;
              }
              $yakugo = $yakugo . $c; 
            }
            $yakugo = yakugo_syori($yakugo);
          }

          $tangos = tangos_syori($tangos);
          table_hyouji2();
          ++$k_cnt;
        }
        else{
          ++$z_cnt;
        }

        if($icchi_kensuu_mode){
          #一致件数を求めるモード
          if($k_cnt >= $dmax){
            #一致件数を求めるためにループから抜けない
            #次から単語/訳語は非表示で一致件数を求めるためだけにループ
            if($icchi_kensuuf == 0){
              $z_cnt = $k_cnt;
            }
            $icchi_kensuuf = 1; 
          }
        }
        else
        if($k_cnt >= $dmax){
          break;
        }
      }
    }
    print("</table>");
    if($k_cnt == 0){
      $hkens = conv2sjis("該当無し");
      if($keitaif == 0){
        print("<script type=\"text/javascript\">\n<!--\ndocument.nabeta2.ntext.value=\"$hkens\"\n-->\n</script>\n");
      }
      if($keitaif){
        print("<br>");
      }
      print ("$hkens<br>\n"); 
    }
    else
    if($icchi_kensuu_mode == 1){
      if($z_cnt <  $k_cnt){
        $z_cnt = $k_cnt;
      }
      $hkens = "$z_cnt" . conv2sjis("件中") .  "$k_cnt" . conv2sjis("件表示");
      if($keitaif == 0){
        print("<script type=\"text/javascript\">\n<!--\ndocument.nabeta2.ntext.value=\"$hkens\"\n-->\n</script>\n");
      }
      if($keitaif){
        print("<br>");
      }
      print ("$hkens<br>\n"); 
    }
    else{
      $hkens = "$k_cnt" . conv2sjis("件表示");
      if($keitaif == 0){
        print("<script type=\"text/javascript\">\n<!--\ndocument.nabeta2.ntext.value=\"$hkens\"\n-->\n</script>\n");
      }
      if($keitaif){
        print("<br>");
      }
      print ("$hkens<br>\n"); 
    }
    fclose($DATA);
    #bubun end
  }
  else
  if(strcmp($smode,"seiki")==0){
    #正規表現検索
    $icchi_kensuu_mode = 0;//時間かかるからやめた
    if(($DATA = fopen($file1,"rb"))==FALSE){
      print("Data file $file1 Open Error(read only)\n");
      exit(1);
    } 

    $len = strlen($input_tango);
    #ヘッダ読み込み
    hedda_yomikomi();
    table_hyouji();

    #全数ループ
    #seiki
    $k_cnt = 0;
    for($i=0;$i<$rec_suu;++$i){
      fseek($DATA, $i * 4 + $index_kaishi_ichi);
      $buf = fread($DATA,4);
      /* if(sizeof($buf) != 4) {
          print("Read ERROR Index file\n");
          fclose($DATA); 
          exit(1);
      }*/
      $tmp = unpack("V",$buf);
      $data_adr = $tmp[1];

      fseek($DATA, $data_adr + $data_kaishi_ichi);
      $tangos = "";
      while (1){
        $c = fgetc($DATA);
        if(strcmp($c,"\0")==0){
          break;
        }
        $tangos = $tangos . $c;
      }

      $seiki_icchi = 0;
      if($oomoji){
        #大文字小文字区別無し
        if(preg_match("/$input_tango/i",$tangos)){
          $seiki_icchi = 1;
        }
      }
      else{
        if(preg_match("/$input_tango/",$tangos)){
          $seiki_icchi = 1;
        }
      }
      if($seiki_icchi){
        if($icchi_kensuuf == 0){ 
          $yakugo = "";
          if($keitaif == 0){
            while (1){
              $c = fgetc($DATA);
              if(strcmp($c,"\0")==0){
                break;
              }
              $yakugo = $yakugo . $c; 
            }
            $yakugo = yakugo_syori($yakugo);
          }

          $tangos = tangos_syori($tangos);
          table_hyouji2();
          ++$k_cnt;
        }
        else{
          ++$z_cnt;
        }

        if($icchi_kensuu_mode){
          #一致件数を求めるモード
          if($k_cnt >= $dmax){
            #一致件数を求めるためにループから抜けない
            #次から単語/訳語は非表示で一致件数を求めるためだけにループ
            if($icchi_kensuuf == 0){
              $z_cnt = $k_cnt;
            }
            $icchi_kensuuf = 1; 
          }
        }
        else
        if($k_cnt >= $dmax){
          break;
        }
      }
    }
    print("</table>");
    if($k_cnt == 0){
      $hkens = conv2sjis("該当無し");
      if($keitaif == 0){
        print("<script type=\"text/javascript\">\n<!--\ndocument.nabeta2.ntext.value=\"$hkens\"\n-->\n</script>\n");
      }
      if($keitaif){
        print("<br>");
      }
      print ("$hkens<br>\n"); 
    }
    else
    if($icchi_kensuu_mode == 1){
      if($z_cnt <  $k_cnt){
        $z_cnt = $k_cnt;
      }
      $hkens = "$z_cnt" . conv2sjis("件中") .  "$k_cnt" . conv2sjis("件表示");
      if($keitaif == 0){
        print("<script type=\"text/javascript\">\n<!--\ndocument.nabeta2.ntext.value=\"$hkens\"\n-->\n</script>\n");
      }
      if($keitaif){
        print("<br>");
      }
      print ("$hkens<br>\n"); 
    }
    else{
      $hkens = "$k_cnt" . conv2sjis("件表示");
      if($keitaif == 0){
        print("<script type=\"text/javascript\">\n<!--\ndocument.nabeta2.ntext.value=\"$hkens\"\n-->\n</script>\n");
      }
      if($keitaif){
        print("<br>");
      }
      print ("$hkens<br>\n"); 
    }
    fclose($DATA);
    #seiki end
  }
  else
  if(strcmp($smode,"kouhou")==0){
    #後方一致検索
    $icchi_kensuu_mode = 0;//時間かかるからやめた
    if(($DATA = fopen($file1,"rb"))==FALSE){
      print("Data file $file1 Open Error(read only)\n");
      exit(1);
    } 

    $len = strlen($input_tango);

    #ヘッダ読み込み
    hedda_yomikomi();
    table_hyouji();

    #全数ループ
    #bubun
    $k_cnt = 0;
    for($i=0;$i<$rec_suu;++$i){
      fseek($DATA, $i * 4 + $index_kaishi_ichi);
      $buf = fread($DATA,4);
      /* if(sizeof($buf) != 4) {
          print("Read ERROR Index file\n");
          fclose($DATA); 
          exit(1);
      }*/
      $tmp = unpack("V",$buf);
      $data_adr = $tmp[1];

      fseek($DATA, $data_adr + $data_kaishi_ichi);
      $tangos = "";
      while (1){
        $c = fgetc($DATA);
        if(strcmp($c,"\0")==0){
          break;   
        }       
        $tangos = $tangos . $c; 
      }
      $kouhou_icchi = 0;
      if(strcmp($tangos,"")==0){
      }
      else{
        if($oomoji){
          $tangos_komoji = strtolower($tangos);
          $sblen = strlen($tangos_komoji);
	  if($sblen >= $itlen){
            $tangos_komoji = substr($tangos_komoji,$sblen-$itlen,$itlen);
            if(strcmp($tangos_komoji,$input_tango)==0){
              $kouhou_icchi = 1;
            }
          }
        }
        else{
          $sblen = strlen($tangos);
	  if($sblen >= $itlen){
            $tangos_komoji = substr($tangos,$sblen-$itlen,$itlen);
            if(strcmp($tangos_komoji,$input_tango)==0){
              $kouhou_icchi = 1;
            }
          }
        }
      }
      if($kouhou_icchi){
        if($icchi_kensuuf == 0){ 
          $yakugo = "";
          if($keitaif == 0){
            while (1){
              $c = fgetc($DATA);
              if(strcmp($c,"\0")==0){
                break;
              }
              $yakugo = $yakugo . $c; 
            }
            $yakugo = yakugo_syori($yakugo);
          }

          $tangos = tangos_syori($tangos);
          table_hyouji2();
          ++$k_cnt;
        }
        else{
          ++$z_cnt;
        }

        if($icchi_kensuu_mode){
          #一致件数を求めるモード
          if($k_cnt >= $dmax){
            #一致件数を求めるためにループから抜けない
            #次から単語/訳語は非表示で一致件数を求めるためだけにループ
            if($icchi_kensuuf == 0){
              $z_cnt = $k_cnt;
            }
            $icchi_kensuuf = 1; 
          }
        }
        else
        if($k_cnt >= $dmax){
          break;
        }
      }
    }
    print("</table>");
    if($k_cnt == 0){
      $hkens = conv2sjis("該当無し");
      if($keitaif == 0){
        print("<script type=\"text/javascript\">\n<!--\ndocument.nabeta2.ntext.value=\"$hkens\"\n-->\n</script>\n");
      }
      if($keitaif){
        print("<br>");
      }
      print ("$hkens<br>\n"); 
    }
    else
    if($icchi_kensuu_mode == 1){
      if($z_cnt <  $k_cnt){
        $z_cnt = $k_cnt;
      }
      $hkens = "$z_cnt" . conv2sjis("件中") .  "$k_cnt" . conv2sjis("件表示");

      if($keitaif == 0){
        print("<script type=\"text/javascript\">\n<!--\ndocument.nabeta2.ntext.value=\"$hkens\"\n-->\n</script>\n");
      }
      if($keitaif){
        print("<br>");
      }
      print ("$hkens<br>\n"); 
    }
    else{
      $hkens = "$k_cnt" . conv2sjis("件表示");
      if($keitaif == 0){
        print("<script type=\"text/javascript\">\n<!--\ndocument.nabeta2.ntext.value=\"$hkens\"\n-->\n</script>\n");
      }
      if($keitaif){
        print("<br>");
      }
      print ("$hkens<br>\n"); 
    }
    fclose($DATA);
    #bubun end
  }


  //fclose($DATA); 二重クローズでエラーになる
  }#単語検索処理
  else{
    #訳語検索
  if(strcmp($smode,"bubun")==0 || strcmp($smode,"seiki")==0){
    #訳語部分一致検索
    $icchi_kensuu_mode = 0;//時間かかるからやめた
    if(($DATA = fopen($file1,"rb"))==FALSE){
      print("Data file $file1 Open Error(read only)\n");
      exit(1);
    }

    $len = strlen($input_tango);

    #ヘッダ読み込み
    hedda_yomikomi();
    table_hyouji();

    #全数ループ
    #訳語bubun,seiki
    $k_cnt = 0;
    for($i=0;$i<$rec_suu;++$i){
      fseek($DATA, $i * 4 + $index_kaishi_ichi);
      $buf = fread($DATA,4);
      /* if(sizeof($buf) != 4) {
          print("Read ERROR Index file\n");
          fclose($DATA); 
          exit(1);
      }*/
      $tmp = unpack("V",$buf);
      $data_adr = $tmp[1];

      fseek($DATA, $data_adr + $data_kaishi_ichi);
      $tangos = "";
      while(1){
        $c = fgetc($DATA);
        if(strcmp($c,"\0")==0){
          break;   
        }       
        $tangos = $tangos . $c; 
      }

      $bubun_icchi = 0;
      if(strcmp($tangos,"")==0){
        #単語名がない。エラー
        contunue;
      }

      $yakugo = "";
      while (1){
        $c = fgetc($DATA);
        if(strcmp($c,"\0")==0){
          break;
        }
        $yakugo = $yakugo . $c; 
      }

      if(strcmp($smode,"bubun")==0){
        #訳語部分一致
       if($oomoji){
          $yakugo_komoji = strtolower($yakugo);
          if(strstr($yakugo_komoji,$input_tango)){
            $bubun_icchi = 1;
          }
        }
        else{
          if(strstr($yakugo,$input_tango)){
            $bubun_icchi = 1;
          }
        }
      }
      else
      if(strcmp($smode,"seiki")==0){
        #訳語正規表現
        if($oomoji){
          #大文字小文字区別無し
          if(preg_match("/$input_tango/i",$yakugo)){
            $bubun_icchi = 1;
          }
        }
        else{
          if(preg_match("/$input_tango/",$yakugo)){
            $bubun_icchi = 1;
          }
        }
      }

      if($bubun_icchi){
        #訳語一致

        if($icchi_kensuuf == 0){ 
          $tangos = tangos_syori($tangos);
          if($keitaif == 0){
            $yakugo = yakugo_syori($yakugo);
          }
          table_hyouji2();
          ++$k_cnt;
        }
        else{
          ++$z_cnt;
        }

        if($icchi_kensuu_mode){
          #一致件数を求めるモード
          if($k_cnt >= $dmax){
            #一致件数を求めるためにループから抜けない
            #次から単語/訳語は非表示で一致件数を求めるためだけにループ
            if($icchi_kensuuf == 0){
              $z_cnt = $k_cnt;
            }
            $icchi_kensuuf = 1; 
          }
        }
        else
        if($k_cnt >= $dmax){
          break;
        }
      }
    }
    print("</table>");
    if($k_cnt == 0){
      $hkens = conv2sjis("該当無し");
      if($keitaif == 0){
        print("<script type=\"text/javascript\">\n<!--\ndocument.nabeta2.ntext.value=\"$hkens\"\n-->\n</script>\n");
      }
      if($keitaif){
        print("<br>");
      }
      print ("$hkens<br>\n"); 
    }
    else
    if($icchi_kensuu_mode == 1){
      if($z_cnt <  $k_cnt){
        $z_cnt = $k_cnt;
      }
      $hkens = "$z_cnt" . conv2sjis("件中") .  "$k_cnt" . conv2sjis("件表示");
      if($keitaif == 0){
        print("<script type=\"text/javascript\">\n<!--\ndocument.nabeta2.ntext.value=\"$hkens\"\n-->\n</script>\n");
      }
      if($keitaif){
        print("<br>");
      }
      print ("$hkens<br>\n"); 
    }
    else{
      $hkens = "$k_cnt" . conv2sjis("件表示");
      if($keitaif == 0){
        print("<script type=\"text/javascript\">\n<!--\ndocument.nabeta2.ntext.value=\"$hkens\"\n-->\n</script>\n");
      }
      if($keitaif){
        print("<br>");
      }
      print ("$hkens<br>\n"); 
    }
    fclose($DATA);
    #yakugo bubun or seiki end
  }

  }#訳語検索処理
}#検索処理全て終わり
else{
  //データ見出し数取得のためだけに読む
  if(($DATA = fopen($file1,"rb"))!=FALSE){
    hedda_yomikomi();
    fclose($DATA);
  } 
}

if($next_rc == 0){
  $moto_k_ichi = $s_rc;
}

if($randomf == 0){
if($oomoji){
  $ens = "d=s";//エンコードした印
  $udumys = "";
  if($sjisf == 0){
    $udumys = "&v=" . $utf8dumys;
  }
  $nrc = "&nc=" . $next_rc_tugi;
  if($next_rc){
    $mrc = "&mr=" . $moto_k_ichi;
    $mzc = "&mz=" . $moto_z_cnt;
  }
  else{
    $mrc = "&mr=" . $s_rc;
    $mzc = "&mz=" . $z_cnt;
  }

  $mic = "&mi=" . $m_ichi;
  $pic = "&nc=" . $get_mi;

  if($pmax == 0){
    $pagez[$pmax] = $m_ichi;
    $pmax++;
    $pagez[$pmax] = $next_rc_tugi;
    $pmax++;
  }
  if($z_cnt > $k_cnt){
    if($page_no+1 >= $pmax){
      $pagez[$pmax] = $next_rc_tugi;
      $pmax++;
    }
  }

  $zpc = "";
  for($i=0;$i<$pmax;$i++){
    $zpc = $zpc . "&p" . $i . "=" . $pagez[$i];
  }

  if($page_no > 0){
    $pnc = "&pn=" . ($page_no - 1);
    $nextlink = "<a href=\"$cgi_name?$ens$udumys$zen_pm$pic$mic$mzc$pnc$zpc\">Previous Page</a>&nbsp;&nbsp;&nbsp;";
    print_us($nextlink);
  }
  if($pmax > $page_no + 1){
    $pnc = "&pn=" . ($page_no+1);
    
    $nextlink = "<a href=\"$cgi_name?$ens$udumys$zen_pm$nrc$mic$mzc$pnc$zpc\">Next Page</a>";
    print_us($nextlink);
  }
}
else
if(($z_cnt > $k_cnt) || ($next_rc_tugi - ($dmax)) >= $moto_k_ichi){
  $ens = "d=s";//エンコードした印
  $udumys = "";
  if($sjisf == 0){
    $udumys = "&v=" . $utf8dumys;
  }
  $nrc = "&nc=" . $next_rc_tugi;
  if($next_rc_tugi - $dmax - $k_cnt > 0){
    $nppc = "&nc=" . ($next_rc_tugi - $dmax - $k_cnt);
  }
  else{
    $nppc = "&nc=0";
  }

  if($next_rc){
    $mrc = "&mr=" . $moto_k_ichi;
    $mzc = "&mz=" . $moto_z_cnt;
  }
  else{
    $mrc = "&mr=" . $s_rc;
    $mzc = "&mz=" . $z_cnt;
    $moto_k_ichi = $s_rc;
  }

  $mc = $next_rc - $moto_k_ichi;//$oomoji=1 でない場合
  
  if(($next_rc_tugi - ($dmax)) >= $moto_k_ichi && $mc > 0){
    $nextlink = "<a href=\"$cgi_name?$ens$udumys$zen_pm$nppc$mzc$mrc\">Previous Page</a>&nbsp;&nbsp;&nbsp;";
    print_us($nextlink);
  }
  if($z_cnt > $k_cnt){
    $nextlink = "<a href=\"$cgi_name?$ens$udumys$zen_pm$nrc$mzc$mrc\">Next Page</a>";
    print_us($nextlink);
  }
}
}

$mcvs = conv2sjis("データ見出し数");
print("<br>$mcvs $rec_suu");


#データ著作権表示ボタン
  print("<br><input name=\"dc\" type=\"submit\" value=\"$data_chosakukens\">");
  print_us("　<a href=\"readme.html\">説明</a><br>\n");
  print("<input type=\"hidden\" name=\"dd\" value=\"$dic_no\">");

  if($keitaif){
    print_us("<a href=phpdockt.html><br>鍋田辞書Pの使い方</a><br>\n");
  }
  else{
    print_us("<a href=phpdoc.html><br>鍋田辞書Pの使い方</a><br>\n");
  }

  print_us("<a href=\"quiz.php?dd=$dic_no\"><br>鍋田辞書クイズP</a><br>");
  print("</form>");


if($mobilef || $keitaif){
  print_us("鍋田辞書P<br>Ver 1.2 (C) 2010-2014<br>大場正輝(Oba Masaki)<br>All Rights Reserved.<br>\n");
} 
else{
  print_us("鍋田辞書P(NabetaJisho P) Ver 1.2 (C) 2010-2014<br>大場正輝(Oba Masaki) All Rights Reserved.<br>\n");
}
print_us("<a href=\"http://www.nabeta.tk/\"><br>鍋田辞書</a>\n");
print("</body></html>\n");
?>
