<?php
#!/usr/local/bin/php
#character code UTF-8.
#鍋田辞書クイズP Ver 1.1
#NabetaJisho Quiz P Ver 1.1 (2013/9/23)
#鍋田辞書クイズP(NabetaJisho Quiz P) Copyright (C) 2012 大場正輝(Oba Masaki) All Rights Reserved.";
#http://wwww.nabeta.tk
#admin@nabeta.tk;
#Windows版 鍋田辞書 Ver 4.2以降からCGI辞書用に出力した辞書データを利用して4択のクイズ選択問題をランダムで自動で作成してクイズを実行するPHPスクリプトです。
#モジュール版PHPのセーフモードに対応しています。
#モジュール版PHPのセーフモードでない方法で動作させる場合は、スクリプト行頭に「#!/usr/local/bin/php」を追加し、スクリプト名の拡張子をcgiに変える必要があるかも知れません。(サーバーの設定で違うと思います。)
#鍋田辞書Windows版から出力したnabeta.cgidatという、ひとつのファイルがデータファイルです。
#このデータは単語のインデックスを持っていてバイナリサーチで検索できます。
#
#ライセンス license
#このPHPスクリプトはフリーソフトですが、著作権を放棄しておりません。
#無料。商用利用可。改変可。改変した場合のソース公開の義務なし。
#再配布可ですが、配布には著作権の表記が必要。
#ネットでオンラインサイトとして公開する場合は、http://www.nabeta.tk/ へのリンクと著作権表記が必要です。
#リンクの例: <a href="http://www.nabeta.tk/">鍋田辞書</a>
#著作権表記の例:鍋田辞書クイズP(NabetaJisho Quiz P)Ver 1.1 Copyright (C) 2012-2013<br>大場正輝(Oba Masaki)<br>All Rights Reserved.
#データのライセンスは別ライセンスになっておりますので各データの各著作権者の決めたルールに従ってください。
#鍋田辞書オリジナルのデータ(鍋田辞書作者が作ったデータ)は、無許可での一般WEB公開を禁止しています。
#ローカル環境で、IP 127.0.0.1からのみアクセスでそれ以外のアクセスを禁止している環境であれば、一般WEB公開や再配布に該当しないので鍋田辞書オリジナルのデータをこのスクリプトで使うことが可能です。
#寄付は受け付けます。「鍋田辞書 Windows版」のヘルプのライセンス説明に銀行口座番号が書いてあります。
#
#
#quiz.php パーミッション 755。ftpはアスキーモードで転送。
#nabeta.cgidat パーミッション はモジュール版PHPセーフモードなら644。そうでないなら600。ftpはバイナリモードで転送。 

#UTF-8とSJISを動的に切り替えることができます。
#ただし、SJISでは外国語文字の多くを表示できす、多くの外国語文字で正常動作しません。
#JavascriptはUTF-8とSJISの切り替えをしたときの自動ページ更新と辞書番号のクッキー保存のみ使っていてJavascriptが使えない環境でも動作します。
#http://xxxx.quiz.php?m=0 でUTF-8
#http://xxxx.quiz.php?m=1 でUTF-8をShift JISに変換して表示(スクリプトはUTF-8)

//例えば、タイ日と、日タイが混ざっている辞書で、
//タイ日のみをランダムで選ぶために文字の言語をチェックする。
//英語やロシア語など指定したい外国語が無い場合、1の日本語以外を指定してください。
//$gengo_h[x]= 0: 文字言語チェック無し
//$gengo_h[x]= 1: 日本語以外(単語が日本語以外のデータ利用)
//$gengo_h[x]= 2: タイ語(単語がタイ語のデータ利用)
//$gengo_h[x]= 3: ラオス語(単語がラオス語のデータ利用)
//$gengo_h[x]= 4: カンボジア語(単語がカンボジア語のデータ利用)
//$gengo_h[x]= 5: ハングル、韓国朝鮮語(単語がハングルのデータ利用)
//$gengo_h[x]= 6: 日本語(単語が日本語のデータ利用)
//$gengo_h[x]のxは、0から始まる辞書番号
//辞書データに存在しない言語の文字は指定しないでください。
$gengo_h[0] = 0;
$gengo_h[1] = 0;
$gengo_h[2] = 0;
$gengo_h[3] = 0;
$gengo_h[4] = 0;
$gengo_h[5] = 0;
$gengo_h[6] = 0;
$gengo_h[7] = 0;
$gengo_h[8] = 0;
$gengo_h[9] = 0;
$gengo_h[10] = 0;
$gengo_h[11] = 0;
$gengo_h[12] = 0;
$gengo_h[13] = 0;
$gengo_h[14] = 0;
$gengo_h[15] = 0;
$gengo_h[16] = 0;
$gengo_h[17] = 0;
$gengo_h[18] = 0;
$gengo_h[19] = 0;

$gengo = $gengo_h[0];

#0:UTF-8
#1:表示をShift JISに変換して表示する(スクリプトはUTF-8)
$mobilemodedef = 0;

#タイトルバーに表示されるタイトルを書く
$titlebar_s = "鍋田辞書クイズP";

$title_s = "<b>鍋田辞書クイズP</b>";



#辞書の数の最大数を指定
$datafile_max = 20;

#データのファイル名を指定
#$dic_data1の設定は必須。
$dic_data[0] = "nabeta.cgidat";
$dic_data[1] = "nabeta2.cgidat";
$dic_data[2] = "nabeta3.cgidat";
$dic_data[3] = "nabeta4.cgidat";
$dic_data[4] = "nabeta5.cgidat";
$dic_data[5] = "nabeta6.cgidat";
$dic_data[6] = "nabeta7.cgidat";
$dic_data[7] = "nabeta8.cgidat";
$dic_data[8] = "nabeta9.cgidat";
$dic_data[9] = "nabeta10.cgidat";
$dic_data[10] = "nabeta11.cgidat";
$dic_data[11] = "nabeta12.cgidat";
$dic_data[12] = "nabeta13.cgidat";
$dic_data[13] = "nabeta14.cgidat";
$dic_data[14] = "nabeta15.cgidat";
$dic_data[15] = "nabeta16.cgidat";
$dic_data[16] = "nabeta17.cgidat";
$dic_data[17] = "nabeta18.cgidat";
$dic_data[18] = "nabeta19.cgidat";
$dic_data[19] = "nabeta20.cgidat";

$file1 = $dic_data[0];

#辞書名を指定
$dic_name[0] = "DIC1";
$dic_name[1] = "DIC2";
$dic_name[2] = "DIC3";
$dic_name[3] = "DIC4";
$dic_name[4] = "DIC5";
$dic_name[5] = "DIC5";
$dic_name[6] = "DIC6";
$dic_name[7] = "DIC7";
$dic_name[8] = "DIC8";
$dic_name[9] = "DIC9";
$dic_name[10] = "DIC10";
$dic_name[11] = "DIC11";
$dic_name[12] = "DIC12";
$dic_name[13] = "DIC13";
$dic_name[14] = "DIC14";
$dic_name[15] = "DIC15";
$dic_name[16] = "DIC16";
$dic_name[17] = "DIC17";
$dic_name[18] = "DIC18";
$dic_name[19] = "DIC19";

#このファイルのファイル名を自動で取得
if(isset($_SERVER['SCRIPT_NAME'])){
  $cgi_name = basename($_SERVER['SCRIPT_NAME']);
}
else{
  $cgi_name = "";
}

#訳語カットサイズ
#一覧表示で訳語をカットするサイズを指定。
#この文字数にカットするのではなく、行末の切りのいい所でカットする。
#一行だけのデータではカットしない。
#携帯電話指定の時は無効。
$yakugo_cut_size = 300;

#データ認識コード
#間違って他のデータを検索しないための鍋田辞書CGIデータという印
$data_version_code = 654018739;


#データ著作権ボタンのvalueに「表」など文字を含む場合、エスケープさせないと動かない環境とさせると動かない環境がある。
#「表」が0x5c「\」を含むからだと思われる。
#データ著作権ボタンから「表」という文字は消した。
#「データ著作権表示」から、「データ著作権」に変更。
$kaitou = "";
if(isset($_GET['rb'])) $kaitou = stripslashes($_GET['rb']);//PHPの勝手にエスケープを元に戻す
$seikai = "";
if(isset($_GET['k'])) $seikai = stripslashes($_GET['k']);//PHPの勝手にエスケープを元に戻す
$link_name = "";
if(isset($_GET['lk'])) $link_name = stripslashes($_GET['lk']);//PHPの勝手にエスケープを元に戻す

$chosakuken = "";
if(isset($_GET['dc'])) $chosakuken = stripslashes($_GET['dc']);//データ著作権ボタン
$mobile_get_str = "";
if(isset($_GET['m'])) $mobile_get_str = $_GET['m'];
$link_encode = "";
if(isset($_GET['d'])) $link_encode = $_GET['d'];
$submit = "";
if(isset($_GET['u'])) $submit = stripslashes($_GET['u']);//SUBMIT

Function make_angou($s)
{
  $a = "";
  $c = 0; 
  $len = strlen($s);
  for($i = 0;$i<$len;++$i){
    $c = ord(substr($s,$i,1));
    ++$c;
    if($c == 0x3b){
      $c = 0x58;
    }
    else
    if($c == 0x3a){
      $c = 0x59;
    }
    else
    if($c < 0x30 || ($c > 0x39 && $c < 0x41) || ($c > 0x5a && $c < 0x61) || $c > 0x7a){
      $c = 0x5a;
    }
    $a .= chr($c);
  }
  return $a;
}

Function make_koyuu_moji()
{
  $Http_host = "";
  $Script_name = "";
  if(isset($_SERVER['HTTP_HOST'])){
    $Http_host = $_SERVER['HTTP_HOST'];
  }

  if(isset($_SERVER['SCRIPT_NAME'])){
    $Script_name = $_SERVER['SCRIPT_NAME'];
  }

  $up = $Http_host;
  if(strncmp($up,"http://",7)== 0){
    $up = substr($up,7,strlen($up)-7);
  }

  if(strstr($up,":")){
    $up = strstr($up,":");
    $up = substr($up,1,strlen($up)-1);
  }
  else{
    $up = "";
  }
  $up2 = $Script_name;
  if(strstr($up2,"?")){
    $up2 = preg_replace("/?.*$/","",$up2);
  }

  $up .= $up2; 
  return "npq" . make_angou($up);
}
$dic_no = 0;
if(isset($_GET['dd'])){
  $dic_moji = $_GET['dd'];
  $dic_no = intval($dic_moji);
}

$mc_dic_no = -1;
$cooks = "";
if(isset($_COOKIE[make_koyuu_moji()])){
  if(strlen($cooks) > 3){
    $cooks = $_COOKIE[make_koyuu_moji()];
  }
}
if($cooks != ""){
  $cooks_h = explode('&', $cooks);
  if($cooks_h[0] != ""){
    $mc_dic_no = intval($cooks_h[0]);
  }
}

if(isset($_GET['dd']) == 0){
  //URL指定に辞書番号がなく、クッキーに辞書選択番号があれば、辞書番号を書き換える。
  //ただし、書き換えた辞書番号の辞書ファイルが存在しなければ辞書番号をリセットする。
  if($mc_dic_no >= 0){
    $dic_no = $mc_dic_no;
    if(file_exists($dic_data[$dic_no]) == 0){
      $dic_no = 0;
    }
  }
}


if($mobile_get_str != ""){
  $mobilemodedef = intval($mobile_get_str);
}

if($mobilemodedef == 0){
  //UTF-8
  $sjisf = 0;
}
else
if($mobilemodedef == 1){
  //Shift JIS
  $sjisf = 1;
}

$yaku_cut = 0;
$mini_yaku_cut = 0;//未使用

Function print_us($s)
{
  global $sjisf;
  if($sjisf){
    $s = iconv('utf-8', 'cp932', $s);
  }
  print $s;
}

Function conv2sjis($s)
{
  global $sjisf;
  if($sjisf){
    $s = iconv('utf-8', 'cp932', $s);
  }
  return $s;
}

Function conv2utf8($s)
{
  global $sjisf;
  if($sjisf){
    $s = iconv('cp932', 'utf8-8', $s);
  }
  return $s;
}

#データの著作権表示ボタンの文字列
#「表」という文字を混ぜると環境により動作しない。
#GETで「\表」とエスケープされるが、エスケープさせて動作する環境としない環境がある。
#「表」が0x5c「\」記号を含んでいるのが原因だと思う。
#面倒くさいので「表」という文字は消した。
$data_chosakukens = conv2sjis('データの著作権');

$chosakuf = 0;
if(strcmp($chosakuken,$data_chosakukens)==0){
  $chosakuf = 1;
}

$mondaistr = conv2sjis('次の問題');

$kaitoustr = conv2sjis('解答');

$tangos = "";
$yakugo = "";

#URLをブラウザに勝手にSJISに変換されないためのダミーUTF8文字列
#$utf8dumys = chr(0xe0) . chr(0xb8) . chr(0x97);
$utf8dumys = '%E0%B8%97';


$input_tango = "";
$link_hyouji = 0;
if(strcmp($link_name,"")){
  if($link_encode === "s"){
    $input_tango = urldecode($link_name);
  }
  else{
    $input_tango = $link_name;
  }
  $link_hyouji = 1;
}

#全角スペース
//$zenkaku_space = "　";
//if($sjisf){
  //$zenkaku_space = iconv('utf-8', 'cp932', $zenkaku_space);
//}

#print("Content-type: text/html\n\n");
  print("<html><head>\n");
  if($sjisf){
    $moji_code="shift_jis";
  }
  else{
    $moji_code="utf-8";
  }
  print("<meta http-equiv=\"Content-Type\" content=\"text/html; charset=$moji_code\">\n");

  $mcvs = "<title>$titlebar_s</title>\n";
  $mcvs .= '<meta NAME="description" content="鍋田辞書クイズP(PHP版)"><meta name="keywords" content="オンライン辞書クイズ,鍋田辞書P,PHP">';
  print_us($mcvs);

  print '<script type="text/javascript" src="./cookieq.mid"></script>';
  print "</head>\n";
  print '<body onload="setcookie();">';


  print("<form name =\"nabeta\" method=get action=./$cgi_name>\n");
  $mcvs = "$title_s\n";
  if($sjisf){
    $mcvs = iconv('utf-8', 'cp932', $mcvs);
  }
  print($mcvs);

  for($i=0;$i<$datafile_max;$i++){
    $selected_h[$i] = "";
  }

  for($i=0;$i<$datafile_max;$i++){
    if($dic_no == $i && $dic_data[$i] != ""){
      $selected_h[$i] = "selected=\"selected\"";
      $file1 = $dic_data[$i];
      $gengo = $gengo_h[$i];
      break;
    }
  }

  print("<select name=\"dd\" size=\"1\" onchange=\"setcookie();submit()\">\n");
  for($i=0;$i<$datafile_max;$i++){
    if(file_exists($dic_data[$i])){
      print_us("<option value=\"$i\" $selected_h[$i]>$dic_name[$i]</option>\n");
    }
  }
  print("</select>\n");
  print_us("　<a href=\"nabeta.php?dd=$dic_no\">辞書</a>");
  print("<br>");


$hh_radio = "type=radio";

Function str_gengo_check($utf8,$gengo)
//例えば、タイ日と、日タイが混ざっている辞書で、
//タイ日のみをランダムで選ぶために文字の言語をチェックする。
//$gengo== 0: 文字言語チェック無し
//$gengo== 1: 日本語以外(単語が日本語以外のデータ利用)
//$gengo== 2: タイ語
//$gengo== 3: ラオス語
//$gengo== 4: カンボジア語
//$gengo== 5: ハングル、韓国朝鮮語
//$gengo== 6: 日本語(単語が日本語のデータ利用)
{
  if($gengo == 0){
    //言語指定が無い場合、常にOKを返す
    return 9999;
  }
  $ucs2s = iconv('UTF-8', 'UCS-4LE', $utf8); // UTF-8 to UCS4
  $ucs2b = str_split($ucs2s,1);
  $len = count($ucs2b)/4;
  for($i = 0;$i<$len;$i++){
    $wc = 0;
    $tmp1 = ord($ucs2b[$i*4]);
    $tmp2 = ord($ucs2b[$i*4+1]);
    $tmp3 = ord($ucs2b[$i*4+2]);
    $tmp4 = ord($ucs2b[$i*4+3]);

    $wc = $tmp1 + ($tmp2 * 0x100) + ($tmp3 * 0x10000) + ($tmp4 * 0x1000000);

    //printf("%x , ",$wc);
    if($gengo == 1){
      //日本語以外かどうかチェック
      //日本語文字(中国語と区別つかない)
      if(($wc >= 0x2eb0 && $wc <= 0x30ff) ||
        ($wc >= 0x31c0 && $wc <= 0x9fff) ||
        ($wc >= 0xf900 && $wc <= 0xfaff) ||
        ($wc >= 0xfe30 && $wc <= 0xfe4f) ||
        ($wc >= 0x20000 && $wc <= 0x2fa1f)){
        //日本語の場合、日本語がある場合、NG
        return -1;
      }
    }
    else
    if($gengo == 2){
      //タイ語文字チェック
      if($wc >= 0xe00 && $wc <= 0xe7f){
        //タイ語文字有り
        return $gengo;
      }
    }
    else
    if($gengo == 3){
      //ラオス語文字チェック
      if($wc >= 0xe80 && $wc <= 0xeff){
        //ラオス語文字有り
        return $gengo;
      }
    }
    else
    if($gengo == 4){
      //カンボジア語文字チェック
      if(($wc >= 0x1780 && $wc <= 0x17ff) ||
        ($wc >= 0x19e0 && $wc <= 0x19ff)){
        //カンボジア語文字有り
        return $gengo;
      }
    }
    else
    if($gengo == 5){
      //ハングル、韓国語朝鮮語文字チェック
      if($wc >= 0xac00 && $wc <= 0xd7ff){
        //ハングル文字有り
        return $gengo;
      }
    }
    else
    if($gengo == 6){
      //日本語かどうかチェック
      //日本語文字(中国語と区別つかない)
      if(($wc >= 0x2eb0 && $wc <= 0x30ff) ||
        ($wc >= 0x31c0 && $wc <= 0x9fff) ||
        ($wc >= 0xf900 && $wc <= 0xfaff) ||
        ($wc >= 0xfe30 && $wc <= 0xfe4f) ||
        ($wc >= 0x20000 && $wc <= 0x2fa1f)){
        return $gengo;
      }
    }
  }
  if($gengo == 1){
    //日本語以外の場合は、日本語が無い場合OK
    return $gengo;
  }
  return -1;
}

Function yakugo_cut_syori_br($yakugo_str)
{
  global $yakugo_cut_size;
  global $mini_yaku_cut;
    $len = strlen($yakugo_str);
    if($len < $yakugo_cut_size){
      return $yakugo_str;
    }
    $a = strpos($yakugo_str,"<br>",1);
    # ==の二個ではなく、===の三個を使う。
    #二個でもエラーにはならないが期待した動作をしない。
    if($a === false || $a == ""){
      #見つからない
    }
    else{
      if($a > $yakugo_cut_size){
        $yakugo_str = substr($yakugo_str,0,$a);
      }
      else{
        $a2 = strpos($yakugo_str,"<br>",$a+4); //$a+4
        if($a2 === false || $a2 == ""){
          #$yakugo_str = substr($yakugo_str,0,$a);
	}
	else{
          if($a2 > $yakugo_cut_size){
            $yakugo_str = substr($yakugo_str,0,$a2);
          }
	  else{
            if($mini_yaku_cut){
              $mae = $a2 + 4;
              while(1){
                $a3 = strpos($yakugo_str,"<br>",$mae);
                if($a3 > $yakugo_cut_size){
                  $yakugo_str = substr($yakugo_str,0,$mae);
                  break;
		}
	        if($a3 === 0 || $a3 == ""){
                  break;
	        }
                $mae = $a3+4;
	      }
            }
	    else{
              $a3 = strpos($yakugo_str,"<br>",$a2+4);
	      if($a3 === 0 || $a3 == ""){
                #$yakugo_str = substr($yakugo_str,0,$a2);
	      }
	      else{
                $yakugo_str = substr($yakugo_str,0,$a3);
	      }
	    }
	  }
        }
      }
    }
  return $yakugo_str;
}

Function yakugo_cut_syori($yakugo_str)
{
  global $yakugo_cut_size;
  global $mini_yaku_cut;
    $len = strlen($yakugo_str);
    if($len < $yakugo_cut_size){
      return $yakugo_str;
    }
    $a = strpos($yakugo_str,",",1);
    # ==の二個ではなく、===の三個を使う。
    #二個でもエラーにはならないが期待した動作をしない。
    if($a === false || $a == ""){
      #見つからない
    }
    else
    if($a > 0){
      if($a > $yakugo_cut_size){
        $yakugo_str = substr($yakugo_str,0,$a);
      }
      else{
        $a2 = strpos($yakugo_str,",",$a+1);
	if($a2 === 0 || $a2 == ""){
          #$yakugo_str = substr($yakugo_str,0,$a);
	}
	else{
          if($a2 > $yakugo_cut_size){
            $yakugo_str = substr($yakugo_str,0,$a2);
          }
	  else{
            if($mini_yaku_cut){
              $mae = $a2 + 1;
              while(1){
                $a3 = strpos($yakugo_str,",",$mae);
                if($a3 > $yakugo_cut_size){
                  $yakugo_str = substr($yakugo_str,0,$mae);
                  break;
		}
	        if($a3 === 0 || $a3 == ""){
                  break;
	        }
                $mae = $a3+1;
	      }
            }
	    else{
              $a3 = strpos($yakugo_str,",",$a2+1);
	      if($a3 === 0 || $a3 == ""){
                #$yakugo_str = substr($yakugo_str,0,$a2);
	      }
	      else{
                $yakugo_str = substr($yakugo_str,0,$a3);
	      }
	    }
	  }
        }
      }
    }
  return $yakugo_str;
}

Function tangos_syori($tangos)
{
  global $cgi_name;
  global $zen_pm;
  global $sjisf;
  global $utf8dumys;

  if($sjisf){
    $tangos = iconv('utf-8', 'cp932', $tangos);
  }
  $tango_url = urlencode($tangos);

  $ens = "d=s";//エンコードした印
  $udumys = "";
  if($sjisf == 0){
    $udumys = "&v=" . $utf8dumys;
  }

  $tangos = "<a href=\"$cgi_name?$ens$udumys&lk=$tango_url$zen_pm\">$tangos</a>";

  return $tangos;
}

Function yakugo_syori($yakugo_str,$cut)
{
  global $ichigyou;
  global $yaku_cut;
  global $mini_yaku_cut;
  global $sjisf;
  $htmlf = 0;

  if($cut){
    //「-------」以降を切る
    if(strlen($yakugo_str) <= 0){
      return $yakugo_str;
    } 
    $a = strpos($yakugo_str,"-------",1);
    # ==の二個ではなく、===の三個を使う。
    #二個でもエラーにはならないが期待した動作をしない。
    if($a === false || $a == ""){
      #見つからない
    }
    else{
      if($a > 0){
        $yakugo_str = substr($yakugo_str,0,$a-1);
      }
    }
  
    //[]で囲った発音記号を取る
    $a = strpos($yakugo_str,"[",0);
    # ==の二個ではなく、===の三個を使う。
    #二個でもエラーにはならないが期待した動作をしない。
    if($a === false || $a == ""){
      #見つからない
    }
    else{
      $zenhan_str = substr($yakugo_str,0,$a-1);
      
      $a = strpos($yakugo_str,"]",$a+1);
      if($a === false || $a == ""){
        #見つからない
      }
      else{
        $len = strlen($yakugo_str);
        if($len > $a){
          $kouhan_str = substr($yakugo_str,$a+1,$len-1);
  	$yakugo_str = $zenhan_str . $kouhan_str;
        }
        else{
  	$yakugo_str = $zenhan_str;
        }
      }
    }
  }

  if($sjisf){
    $yakugo_str = iconv('utf-8', 'cp932', $yakugo_str);
  }
  if(preg_match("/^[ 	\r\n]*<html>/i",$yakugo_str)){
    $htmlf = 1;
  }
  if($htmlf){
    $yakugo_str = preg_replace("/^[ 	\r\n]*<html>/i","",$yakugo_str);
    $yakugo_str = preg_replace("/<\/html>/i","",$yakugo_str);
    if($yaku_cut || $mini_yaku_cut){
      $yakugo_str = yakugo_cut_syori_br($yakugo_str);
    }
    if($ichigyou){
      $yakugo_str = preg_replace("/<br>/i",",",$yakugo_str);
    }

    $yakugo_str = preg_replace("/link:\/\//i","$cgi_name?$udumys&lk=",$yakugo_str);
    return $yakugo_str;
  }
  else
  if($ichigyou == 0){
    $yakugo_str = preg_replace("/\r\n/","<br>",$yakugo_str);
    $yakugo_str = preg_replace("/\n/","<br>",$yakugo_str);
    $yakugo_str = preg_replace("/\r/","<br>",$yakugo_str);
    if($yaku_cut || $mini_yaku_cut){
      $yakugo_str = yakugo_cut_syori_br($yakugo_str);
    }
  }
  else{
    $yakugo_str = preg_replace("/\r\n/",",",$yakugo_str);
    $yakugo_str = preg_replace("/\n/",",",$yakugo_str);
    $yakugo_str = preg_replace("/\r/",",",$yakugo_str);
    if($yaku_cut || $mini_yaku_cut){
      $yakugo_str = yakugo_cut_syori($yakugo_str);
    }
  }
  return $yakugo_str;
}

Function hedda_yomikomi()
{
    #先頭にシーク
    #fseek($DATA, 0);
    #ファイル識別子読み込み
    global $DATA;
    global $data_version_code;
    global $rec_suu;
    global $index_kaishi_ichi;
    global $data_kaishi_ichi;

    $buf = fread($DATA,4);
    /* if (sizeof($buf) != 4) {
        print("Read ERROR Index file\n");
        fclose($DATA); 
        exit(1);
    }*/
    $version_code = unpack("V",$buf);
    if($version_code[1] != $data_version_code){
      print("EROR $file1 is not Nabeta CGI data file\n");
      fclose($DATA); 
      exit(1);
    }

    #レコード数読み込み(データ数)(見出し数)
    $buf = fread($DATA,4);
    /* if(strlen($buf)!= 4) {
        print("Read ERROR Index file\n");
        fclose($DATA); 
        exit(1);
    }*/
    $tmp = unpack("V",$buf);
    $rec_suu = $tmp[1];
    if($rec_suu == 0){
      print("EROR Data size zero.$file1\n");
      fclose($DATA); 
      exit(1);
    }
    #インデックス開始位置数読み込み
    $buf = fread($DATA,4);
    /* if(sizeof($buf) != 4) {
        print("Read ERROR Index file\n");
        fclose($DATA); 
        exit(1);
    }*/
    $tmp = unpack("V",$buf);
    $index_kaishi_ichi = $tmp[1];
    if($index_kaishi_ichi == 0){
      print("EROR Data size zero.$file1\n");
      fclose($DATA); 
      exit(1);
    }

    #データ開始位置数読み込み
    $buf = fread($DATA,4);
    /* if(sizeof($buf) != 4) {
        print("Read ERROR Index file\n");
        fclose($DATA); 
        exit(1);
    }*/
    $tmp = unpack("V",$buf);
    $data_kaishi_ichi = $tmp[1];
    if($data_kaishi_ichi == 0){
      print("EROR Data size zero.$file1\n");
      fclose($DATA); 
      exit(1);
    }
}

Function rec_yomikomi($rec_no)
{
    global $DATA;
    global $data_version_code;
    global $rec_suu;
    global $index_kaishi_ichi;
    global $data_kaishi_ichi;
    global $tangos;
    global $yakugo;

    $tangos = "";
    $yakugo = "";
    if($rec_no >= $rec_suu){
      return;
    }
    fseek($DATA, $rec_no * 4 + $index_kaishi_ichi);
    $buf = fread($DATA,4);
    /* if(sizeof($buf) != 4) {
        print("Read ERROR Index file\n");
        fclose($DATA); 
        exit(1);
    }*/
    $tmp = unpack("V",$buf);
    $data_adr = $tmp[1];

    fseek($DATA, $data_adr + $data_kaishi_ichi);
    $tangos = "";
    while(1){
      $c = fgetc($DATA);
      if(strcmp($c,"\0")==0){
        break;   
      }       
      $tangos = $tangos . $c; 
    }

    if(strcmp($tangos,"")==0){
      #単語名がない。エラー
    }
    else{
      $yakugo = "";
      while (1){
        $c = fgetc($DATA);
        if(strcmp($c,"\0")==0){
          break;
        }
        $yakugo = $yakugo . $c; 
      }
    }
}

Function tango_yomikomi($rec_no)
{
    global $DATA;
    global $data_version_code;
    global $rec_suu;
    global $index_kaishi_ichi;
    global $data_kaishi_ichi;
    global $tangos;

    $tangos = "";
    $yakugo = "";
    if($rec_no >= $rec_suu){
      return;
    }
    fseek($DATA, $rec_no * 4 + $index_kaishi_ichi);
    $buf = fread($DATA,4);
    /* if(sizeof($buf) != 4) {
        print("Read ERROR Index file\n");
        fclose($DATA); 
        exit(1);
    }*/
    $tmp = unpack("V",$buf);
    $data_adr = $tmp[1];

    fseek($DATA, $data_adr + $data_kaishi_ichi);
    $tangos = "";
    while(1){
      $c = fgetc($DATA);
      if(strcmp($c,"\0")==0){
        break;   
      }       
      $tangos = $tangos . $c; 
    }
}

$nabeta_s1 = array();
$nabeta_s2 = array();
$nabeta_s1len = 0;
$nabeta_s2len = 0;

#鍋田辞書独自のソート順の文字列比較のための文字列を数字配列に変換。
#文字列先頭の7ビットのアスキーコードだけ順番が違う。
#NULLが最も小さく次にa-z,A-Z,、その他の7ビットの記号、後は通常のUnicode順
#もし、データが他のソート順であればここを変更しないといけない
Function nabeta_str2s1($sin)
{
  #$tmp = unpack("C*",$sin);
  global $nabeta_s1;
  global $nabeta_s1len;
  $mscd_str = str_split($sin);
  #$len = sizeof($mscd_str);
  $len = strlen($sin);
  $nabeta_s1len = $len;
  for($i=0;$i<$len;++$i){
    $cc = ord($mscd_str[$i]);
    #$tmp = unpack("C",$mscd_str[$i]);これでもよい
    #$cc = $tmp[1];
    if($i != 0){
      $nabeta_s1[$i] = $cc;
    }
    else
    if($cc >= 0x80){
      $nabeta_s1[$i] = $cc;
    }
    else
    if($cc == 0){
      #あり得ないパターン
      $nabeta_s1[$i] = $cc;
    }
    else
    if($cc <= 0x40){
      #記号1
      #53=ローマ字小文字26+ローマ字大文字26+NULL
      $nabeta_s1[$i] = $cc + 52 + 1;
    }
    else
    if($cc <= 0x5a){
      #A-Z
      #A=0x41
      $nabeta_s1[$i] = $cc - 0x41 + 26 + 1;
    }
    else
    if($cc <= 0x60){
      #記号2
      #53=ローマ字小文字26+ローマ字大文字26+NULL1
      $nabeta_s1[$i] = $cc - 0x5b + 52 + 0x40 + 1;
    }
    else
    if($cc <= 0x7a){
     #a-z
     #a=0x61
      $nabeta_s1[$i] = $cc - 0x61 + 1;
    }
    else
    if($cc <= 0x7f){
      #記号2
      #53=ローマ字小文字26+ローマ字大文字26+NULL1
      $nabeta_s1[$i] = $cc - 0x7b + 52 + 0x46 + 1;
    }
  }
}

Function nabeta_str2s2($sin)
{
  global $nabeta_s2;
  global $nabeta_s2len;
  #$tmp = unpack("C*",$sin);
  $mscd_str = str_split($sin);
  #$len = sizeof($mscd_str);
  $len = strlen($sin);
  $nabeta_s2len = $len;
  for($i=0;$i<$len;++$i){
    $cc = ord($mscd_str[$i]);
    #$tmp = unpack("C",$mscd_str[$i]);これでもよい
    #$cc = $tmp[1];
    if($i != 0){
      $nabeta_s2[$i] = $cc;
    }
    else
    if($cc >= 0x80){
      $nabeta_s2[$i] = $cc;
    }
    else
    if($cc == 0){
      #あり得ないパターン
      $nabeta_s2[$i] = $cc;
    }
    else
    if($cc <= 0x40){
      #記号1
      #53=ローマ字小文字26+ローマ字大文字26+NULL
      $nabeta_s2[$i] = $cc + 52 + 1;
    }
    else
    if($cc <= 0x5a){
      #A-Z
      #A=0x41
      $nabeta_s2[$i] = $cc - 0x41 + 26 + 1;
    }
    else
    if($cc <= 0x60){
      #記号2
      #53=ローマ字小文字26+ローマ字大文字26+NULL1
      $nabeta_s2[$i] = $cc - 0x5b + 52 + 0x40 + 1;
    }
    else
    if($cc <= 0x7a){
     #a-z
     #a=0x61
      $nabeta_s2[$i] = $cc - 0x61 + 1;
    }
    else
    if($cc <= 0x7f){
      #記号2
      #53=ローマ字小文字26+ローマ字大文字26+NULL1
      $nabeta_s2[$i] = $cc - 0x7b + 52 + 0x46 + 1;
    }
  }
  #my $n_str = pack "C*", $mscd; パックできない
}



#文字列を鍋田辞書独自のソート順に変換した数値配列の大小を比較
Function nabeta_strcmp()
{
  global $nabeta_s1;
  global $nabeta_s2;
  global $nabeta_s1len;
  global $nabeta_s2len;
  $len1 = $nabeta_s1len;
  $len2 = $nabeta_s2len;


  if($len1 > $len2){
    $lenns = $len2;
  }
  else{
    $lenns = $len1;
  }
  for($i=0;$i < $lenns;++$i){
    if($nabeta_s1[$i] > $nabeta_s2[$i]){
      #s1,左が大きい
      return 1;
    }
    else
    if($nabeta_s1[$i] < $nabeta_s2[$i]){
      #s1,左が小さい
      return -1;
    }
  }

  if($len1 > $len2){
    #s1,左が大きい
    return 1;
  }
  else
  if($len1 < $len2){
    #s1,左が小さい
    return -1;
  }
  else{
    #同じ
    return 0;
  }
}

  #単語クリック時に渡すパラメーターセット
  $zen_pm = "";

  $zen_pm = "&dd=$dic_no";
  if($sjisf){
    $zen_pm = $zen_pm . "&m=1";
  }
  else{
    $zen_pm = $zen_pm . "&m=0";
  }

if($link_hyouji == 1){
    if(($DATA = fopen($file1,"rb"))==FALSE){
      print("Data file $file1 Open Error(read only)\n");
      exit(1);
    } 

    $input_tango = conv2utf8($input_tango); //SJISの場合はUTF-8に変換
    $len = strlen($input_tango);
    
    #ヘッダ読み込み
    hedda_yomikomi();

    $left = 0;
    $right = $rec_suu-1;
    $icchi = 0;
    #kanzen
    $k_cnt = 0;
    nabeta_str2s2($input_tango);
    while(1){
      if($left <= $right){
      }
      else{
        break;
      }
      $mid = intval(($left + $right) / 2); 
      fseek($DATA, $mid * 4 + $index_kaishi_ichi);
      $buf = fread($DATA,4);
      /* if(sizeof($buf) != 4) {
          print("Read ERROR Index file\n");
          fclose($DATA); 
          exit(1);
      }*/
      $tmp = unpack("V",$buf);
      $data_adr = $tmp[1];

      fseek($DATA, $data_adr + $data_kaishi_ichi);
      $tangos = "";
      while (1){
        $c = fgetc($DATA);
        if(strcmp($c,"\0")==0){
          break;
        }       
        $tangos = $tangos . $c; 
      }
      nabeta_str2s1($tangos);
      $cmp = nabeta_strcmp();
      $icchi = 0;
      if($cmp == 0){
        #データが完全一致
        $icchi = 1;
      }
      else
      if($cmp < 0){
        #文字列比較 tangos < input_tango
        # midより左側にinput_tangoは存在しない
        $left = $mid + 1;
      }
      else{
        # midより右側にinput_tangoは存在しない
        $right = $mid - 1;
      }

      if(strcmp($tangos,"")==0){
      }
      else
      if($icchi == 1){
          $yakugo = "";
          while (1){
            $c = fgetc($DATA);
            if(strcmp($c,"\0")==0){
              break;
            }
            $yakugo = $yakugo . $c; 
          }
          $yakugo = yakugo_syori($yakugo,0);

        $tangos = tangos_syori($tangos);
        ++$k_cnt;

        print("<font size=\"+1\">$tangos</font><br><hr>$yakugo<br>");
        break;
      }
    }
    if($k_cnt == 0){
      $hkens ="該当無し";
      print("<br>");
      print_us("$hkens<br>\n"); 
    }
    fclose($DATA);
}

if($submit == $kaitoustr){
  $tango_url = urlencode($kaitou);

  $ens = "d=s";//エンコードした印
  $udumys = "";
  if($sjisf == 0){
    $udumys = "&v=" . $utf8dumys;
    $kaitoul2 = $kaitou;
  }
  else{
    //SJISをUTF-8に変換
    $kaitoul2 = conv2utf8($kaitou);
  }

  $kaitoulink = "<a href=\"$cgi_name?$ens$udumys&lk=$tango_url$zen_pm\">$kaitoul2</a>";

  if($seikai == $kaitou){
   $mcvs = "<font color=\"#0000ff\"><h3>正解</h3></font>";
  }
  else{
    if($kaitou == ""){
      $mcvs = "<font color=\"#ff0000\"><h3>未解答で不正解</h3></font><br><br>";
    }
    else{
      $mcvs = "<font color=\"#ff0000\"><h3>不正解</h3></font>あなたの解答:$kaitoulink<br><br>";
    }
  }

  print_us($mcvs);

  print("<font size=\"+1\">$seikai</font><br><hr>");
  //
    if(($DATA = fopen($file1,"rb"))==FALSE){
      print("Data file $file1 Open Error(read only)\n");
      exit(1);
    } 

    $input_tango = conv2utf8($seikai); //SJISの場合はUTF-8に変換
    $len = strlen($input_tango);
    
    #ヘッダ読み込み
    hedda_yomikomi();

    $left = 0;
    $right = $rec_suu-1;
    $icchi = 0;
    #kanzen
    $k_cnt = 0;
    nabeta_str2s2($input_tango);
    while(1){
      if($left <= $right){
      }
      else{
        break;
      }
      $mid = intval(($left + $right) / 2); 
      fseek($DATA, $mid * 4 + $index_kaishi_ichi);
      $buf = fread($DATA,4);
      $tmp = unpack("V",$buf);
      $data_adr = $tmp[1];

      fseek($DATA, $data_adr + $data_kaishi_ichi);
      $tangos = "";
      while (1){
        $c = fgetc($DATA);
        if(strcmp($c,"\0")==0){
          break;
        }       
        $tangos = $tangos . $c; 
      }
      nabeta_str2s1($tangos);
      $cmp = nabeta_strcmp();
      $icchi = 0;
      if($cmp == 0){
        #データが完全一致
        $icchi = 1;
      }
      else
      if($cmp < 0){
        #文字列比較 tangos < input_tango
        # midより左側にinput_tangoは存在しない
        $left = $mid + 1;
      }
      else{
        # midより右側にinput_tangoは存在しない
        $right = $mid - 1;
      }

      if(strcmp($tangos,"")==0){
      }
      else
      if($icchi == 1){
          $yakugo = "";
          while (1){
            $c = fgetc($DATA);
            if(strcmp($c,"\0")==0){
              break;
            }
            $yakugo = $yakugo . $c; 
          }
          $yakugo = yakugo_syori($yakugo,0);

          //$tangos = tangos_syori($tangos);
        ++$k_cnt;

        print("$yakugo<br><br>");
        break;
      }
    }
    fclose($DATA);
  //

  $mcvs = "次の問題";
}
else
if($chosakuf == 0 && $link_hyouji == 0 && $chosakuf == 0){
if($kaitou == ""){
  //問題作成
  if(($DATA = fopen($file1,"rb"))==FALSE){
    print("Data file $file1 Open Error(read only)\n");
    exit(1);
  } 

  #ヘッダ読み込
  hedda_yomikomi();
  if($rec_suu >= 4){
    //データ件数が一件以上。
    $gcnt = 0;
    while(1){
      $seikai_no = rand(0,$rec_suu-1);
      tango_yomikomi($seikai_no);
      if(str_gengo_check($tangos,$gengo) > 0){
        break;
      }
      $gcnt++;
      if($gcnt > 200){
        print "Error: no such character code of selected language in data.(\$gengo_h[$dic_no]=$gengo;)<br>mismatch selected language and data.<br>please change data or fix select language.  example: \$gengo_h[$dic_no]=0;<br>\n";
	$gengo_h[$dic_no] = 0;
	$gengo = 0;
	break;
      }
    }

    $gcnt = 0;
    while(1){
      $uso1_no = rand(0,$rec_suu-1);
      while($uso1_no == $seikai_no){
        $uso1_no = rand(0,$rec_suu-1);
      }
      tango_yomikomi($uso1_no);
      if(str_gengo_check($tangos,$gengo) > 0){
        break;
      }
      $gcnt++;
      if($gcnt > 200){
        print "Error: no such character code of selected language in data.(\$gengo_h[$dic_no]=$gengo;)<br>mismatch selected language and data.<br>please change data or fix select language.  example: \$gengo_h[$dic_no]=0;<br>\n";
	$gengo_h[$dic_no] = 0;
	$gengo = 0;
	break;
      }
    }
    $uso1_tango = conv2sjis($tangos);
    $uso1_tango_link = tangos_syori($tangos);

    $gcnt = 0;
    while(1){
      $uso2_no = rand(0,$rec_suu-1);
      while($uso2_no == $seikai_no || $uso2_no == $uso1_no){
        $uso2_no = rand(0,$rec_suu-1);
      }
      tango_yomikomi($uso2_no);
      if(str_gengo_check($tangos,$gengo) > 0){
        break;
      }
      $gcnt++;
      if($gcnt > 200){
        print "Error: no such character code of selected language in data.(\$gengo_h[$dic_no]=$gengo;)<br>mismatch selected language and data.<br>please change data or fix select language.  example: \$gengo_h[$dic_no]=0;<br>\n";
	$gengo_h[$dic_no] = 0;
	$gengo = 0;
	break;
      }
    }
    $uso2_tango = conv2sjis($tangos);
    $uso2_tango_link = tangos_syori($tangos);


    $gcnt = 0;
    while(1){
      $uso3_no = rand(0,$rec_suu-1);
      while($uso3_no == $seikai_no || $uso3_no == $uso1_no || $uso3_no == $uso2_no){
        $uso3_no = rand(0,$rec_suu-1);
      }
      tango_yomikomi($uso3_no);
      if(str_gengo_check($tangos,$gengo) > 0){
        break;
      }
      $gcnt++;
      if($gcnt > 200){
        print "Error: no such character code of selected language in data.(\$gengo_h[$dic_no]=$gengo;)<br>mismatch selected language and data.<br>please change data or fix select language.  example: \$gengo_h[$dic_no]=0;<br>\n";
	$gengo_h[$dic_no] = 0;
	$gengo = 0;
	break;
      }
    }
    $uso3_tango = conv2sjis($tangos);
    $uso3_tango_link = tangos_syori($tangos);

    rec_yomikomi($seikai_no);
    $seikai_tango = conv2sjis($tangos);
    $seikai_tango_link = tangos_syori($tangos);
    $yaku_cut = 1;
    $seikai_yakugo = yakugo_syori($yakugo,1);
    $yaku_cut = 0;

  
    fclose($DATA);
  }

  print("$seikai_yakugo<br><hr>\n");

  $rds = rand(0,3);

  if($rds == 0){
    print("<input name=\"rb\" value=\"$seikai_tango\" $hh_radio>$seikai_tango_link<br>\n");
    print("<input name=\"rb\" value=\"$uso1_tango\" $hh_radio>$uso1_tango_link<br>\n");
    print("<input name=\"rb\" value=\"$uso2_tango\" $hh_radio>$uso2_tango_link<br>\n");
    print("<input name=\"rb\" value=\"$uso3_tango\" $hh_radio>$uso3_tango_link<br><br>\n");
  }
  else
  if($rds == 1){
    print("<input name=\"rb\" value=\"$uso1_tango\" $hh_radio>$uso1_tango_link<br>\n");
    print("<input name=\"rb\" value=\"$seikai_tango\" $hh_radio>$seikai_tango_link<br>\n");
    print("<input name=\"rb\" value=\"$uso2_tango\" $hh_radio>$uso2_tango_link<br>\n");
    print("<input name=\"rb\" value=\"$uso3_tango\" $hh_radio>$uso3_tango_link<br><br>\n");
  }
  else
  if($rds == 2){
    print("<input name=\"rb\" value=\"$uso1_tango\" $hh_radio>$uso1_tango_link<br>\n");
    print("<input name=\"rb\" value=\"$uso2_tango\" $hh_radio>$uso2_tango_link<br>\n");
    print("<input name=\"rb\" value=\"$seikai_tango\" $hh_radio>$seikai_tango_link<br>\n");
    print("<input name=\"rb\" value=\"$uso3_tango\" $hh_radio>$uso3_tango_link<br><br>\n");
  }
  else
  if($rds == 3){
    print("<input name=\"rb\" value=\"$uso1_tango\" $hh_radio>$uso1_tango_link<br>\n");
    print("<input name=\"rb\" value=\"$uso2_tango\" $hh_radio>$uso2_tango_link<br>\n");
    print("<input name=\"rb\" value=\"$uso3_tango\" $hh_radio>$uso3_tango_link<br>\n");
    print("<input name=\"rb\" value=\"$seikai_tango\" $hh_radio>$seikai_tango_link<br><br>\n");
  }
  $mcvs = "解答";

  //CGIに渡す正解単語
  print("<input name=\"k\" type=\"hidden\" value=\"$seikai_tango\">\n");
}
else{
  //データ見出し数取得のためだけに読む
  if(($DATA = fopen($file1,"rb"))!=FALSE){
    hedda_yomikomi();
    fclose($DATA);
  } 
  $mcvs = "次の問題";
}
}
else{
  //データ見出し数取得のためだけに読む
  if(($DATA = fopen($file1,"rb"))!=FALSE){
    hedda_yomikomi();
    fclose($DATA);
  } 
  $mcvs = "次の問題";
}


  print_us("<input name=\"u\" type=\"submit\" value=\"$mcvs\"><br><br>\n");


  $selected1kj = "";
  $selected2kj = "";
  if($sjisf){
    $selected2kj = "selected=\"selected\"";
  }
  else{
    $selected1kj = "selected=\"selected\"";
  }
  print("<select name=\"m\" size=\"1\" onchange=\"submit()\">\n");
  print("<option value=\"0\" $selected1kj>UTF-8</option>\n");
  print("<option value=\"1\" $selected2kj>SJIS</option>\n");
  print("</select>");
  print("<br>");

if($chosakuf){
  global $yaku_cut;
  if(($DATA = fopen($file1,"rb"))==FALSE){
    print("Data file $file1 Open Error(read only)\n");
    exit(1);
  } 
  hedda_yomikomi();

  $yakugo = "";
  while (1){
    $c = fgetc($DATA);
    if(strcmp($c,"\0")==0){
      break;   
    }       
    $yakugo = $yakugo . $c; 
  }

  $yaku_cut = 0;
  if($yakugo == ""){
    print("<br>no data\n");
  }
  else{
    $yakugo = yakugo_syori($yakugo,0);

    print("<br>$yakugo\n");
  }
  print("</form>");
  print("</body></html>\n");
  fclose($DATA); 
  exit(2);
}




$mcvs = "データ見出し数";
print_us("<br>$mcvs $rec_suu");


#データ著作権表示ボタン(データ著作権者のライセンスによって変更可)
  print("<br><input name=\"dc\" type=\"submit\" value=\"$data_chosakukens\"><br>\n");


  #$tukaikata = "<a href=http://www.nabeta.tk/onlinethai/nabetathai.php><br>鍋田辞書タイ語(オンライン)</a><br><br>\n";
  $tukaikata = "<a href=nabeta.php?dd=$dic_no><br>鍋田辞書P</a><br><br>\n";
  print_us($tukaikata);

  print("</form>");


  $chosakuken1 = "鍋田辞書クイズP(NabetaJisho Quiz P)<br>Ver 1.1 Copyright (C) 2012-2013<br>大場正輝(Oba Masaki)<br>All Rights Reserved.<br>\n";
  $chosakuken2 = "<a href=\"http://www.nabeta.tk/\"><br>辞書ソフト 鍋田辞書</a>\n";
  print_us($chosakuken1);
  print_us($chosakuken2);  
print("</body></html>\n");
?>
